<?php

class bilder{

var $_db;



function dreheBild($bild, $richtung){
	/*
	$bild = Pfad zum Bild
	$richtung = 'gegen' oder 'im' für 'gegen der Uhrzeigersinn' bzw. 'im Uhrzeigersinn'
	*/
	$winkel = ($richtung=='gegen')?90:270;
	$source = imagecreatefromjpeg($bild);
	$rotate = imagerotate($source, $winkel, 0);
	$tmpname = md5(microtime().$bild);
	imagejpeg($rotate, PFAD_TMP.$tmpname);

	# Rückgabe = Name des Bildes im tmp-Verzeichnis
	return $tmpname;
}

function erzeugeKleineBilder($tmpname, $bildid, $verzeichnis, $nurkleines = false){
	$_maxgroessen = array(
		'br_gr' => 720, # Breite für Bilder im Querformat
		'ho_gr' => 640, # Höhe für Bilder im Hochformat
		'br_kl' => 150, # Breite und
		'ho_kl' => 100  # Höhe für die kleinen Bilder (egal ob das Original Quer- oder Hochformat hat)
	);
	$_qualitaet = 85;

	$original = PFAD_TMP.$tmpname;
	
	# Bildtyp und Abmessungen bestimmen
	$info = @getimagesize($original);
	if($info === false){
		return false; # die angegebene Datei ist kein Bild
	}
	
	if($info[2] != IMAGETYPE_JPEG){# and $info[2] != IMAGETYPE_PNG and $info[2] != IMAGETYPE_GIF
		return false; # ein nicht unterstützter Bildtyp
	}
	
	$original_breite = $info[0];
	$original_hoehe  = $info[1];

	$_querformat = $original_breite>$original_hoehe;
	$_verhaeltnis = $original_breite/$original_hoehe;

	ini_set('memory_limit', '70M');
	$quelle = imagecreatefromjpeg($original);
	if($_querformat){ # Querformat
		# großes Bild erzeugen
		if(!$nurkleines){
			if($original_breite < $_maxgroessen['br_gr']){ # Bild ist kleiner als maximale Größe
				$ziel_breite = $original_breite;
				$ziel_hoehe = $original_hoehe;
				copy($original, $verzeichnis.$bildid.'.jpg');
			}
			else{
				$ziel_breite = $_maxgroessen['br_gr'];
				$ziel_hoehe = round($ziel_breite/$_verhaeltnis);
				$ziel = imagecreatetruecolor($ziel_breite, $ziel_hoehe);
				imagecopyresampled($ziel, $quelle, 0, 0, 0, 0, $ziel_breite, $ziel_hoehe, $original_breite, $original_hoehe);
				imagejpeg($ziel, $verzeichnis.$bildid.'.jpg', $_qualitaet);
				imagedestroy($ziel);
			}
			$query = "UPDATE ".DB_PREFIX."bilder_bilder SET breite = ".$ziel_breite.", hoehe = ".$ziel_hoehe." WHERE id = ".$bildid;
			$this->_db->fuehreQueryAus($query);
		}
		# kleines Bild erzeugen
		$ziel_breite = $_maxgroessen['br_kl'];
		$ziel_hoehe = $_maxgroessen['ho_kl'];
		$_verhaeltnis_kl = $ziel_breite/$ziel_hoehe;
		$kopieren_ab_y = $einfuegen_ab_y = 0;
		$original_hoehe_berechnet = $original_hoehe;
		$ziel_hoehe_berechnet = $ziel_hoehe;
		if($original_breite/$_verhaeltnis_kl < $original_hoehe){ # Originalbild ist zu hoch, Ausschnitt verwenden
			$original_hoehe_berechnet = $original_breite/$_verhaeltnis_kl;
			$kopieren_ab_y = ($original_hoehe-$original_hoehe_berechnet)/4;
			
		}
		$ziel = imagecreatetruecolor($ziel_breite, $ziel_hoehe);
		imagecopyresampled($ziel, $quelle, 0, $einfuegen_ab_y, 0, $kopieren_ab_y, $ziel_breite, $ziel_hoehe_berechnet, $original_breite, $original_hoehe_berechnet);
		imagejpeg($ziel, $verzeichnis.$bildid.'_kl.jpg', $_qualitaet);
		imagedestroy($ziel);
	}
	else{ # Hochformat
		if(!$nurkleines){
			# großes Bild erzeugen
			if($original_hoehe < $_maxgroessen['ho_gr']){ # Bild ist kleiner als maximale Höhe
				$ziel_breite = $original_breite;
				$ziel_hoehe = $original_hoehe;
				copy($original, $verzeichnis.$bildid.'.jpg');
			}
			else{
				$ziel_hoehe = $_maxgroessen['ho_gr'];
				$ziel_breite = round($ziel_hoehe*$_verhaeltnis);
				$ziel = imagecreatetruecolor($ziel_breite, $ziel_hoehe);
				imagecopyresampled($ziel, $quelle, 0, 0, 0, 0, $ziel_breite, $ziel_hoehe, $original_breite, $original_hoehe);
				imagejpeg($ziel, $verzeichnis.$bildid.'.jpg', $_qualitaet);
				imagedestroy($ziel);
			}
			$query = "UPDATE ".DB_PREFIX."bilder_bilder SET breite = ".$ziel_breite.", hoehe = ".$ziel_hoehe." WHERE id = ".$bildid;
			$this->_db->fuehreQueryAus($query);
		}
		
		# kleines Bild erzeugen
		$ziel_breite = $_maxgroessen['br_kl'];
		$ziel_hoehe = $_maxgroessen['ho_kl'];
		$_verhaeltnis_kl = $ziel_breite/$ziel_hoehe;
		$kopieren_ab_y = $einfuegen_ab_y = 0;
		$original_hoehe_berechnet = $original_hoehe;
		$ziel_hoehe_berechnet = $ziel_hoehe;

		if($original_breite/$_verhaeltnis_kl < $original_hoehe){ # Originalbild ist zu hoch, Ausschnitt verwenden
			$original_hoehe_berechnet = $original_breite/$_verhaeltnis_kl;
			$kopieren_ab_y = ($original_hoehe-$original_hoehe_berechnet)/4;
		}
		elseif($original_breite/$_verhaeltnis_kl > $original_hoehe){ # Originalbild ist zu niedrig, im Ausgabebild Streifen lassen
			$ziel_hoehe_berechnet = $ziel_breite/$_verhaeltnis;
			$einfuegen_ab_y = ($ziel_hoehe-$ziel_hoehe_berechnet)/2;
		}
		$ziel = imagecreatetruecolor($ziel_breite, $ziel_hoehe);
		imagecopyresampled($ziel, $quelle, 0, $einfuegen_ab_y, 0, $kopieren_ab_y, $ziel_breite, $ziel_hoehe_berechnet, $original_breite, $original_hoehe_berechnet);
		imagejpeg($ziel, $verzeichnis.$bildid.'_kl.jpg', $_qualitaet);
		imagedestroy($ziel);
	}
	imagedestroy($quelle);
	return true;	
}
	
	
function holeVerzeichnis($albumid, $anlegen = false){
	$dir = $this->_baueVerzeichnis($albumid, $anlegen);
	if(!is_dir($dir)){
		return false;
	}
	else{
		return $dir;
	}
}

function _baueVerzeichnis($albumid, $anlegen){
	$str = str_pad($albumid, 5, '0', STR_PAD_LEFT);
	$anz = strlen($str);
	$dir = PFAD_BILDER.'alben/';
	for($i=0;$i<$anz;$i++){
		$dir .= $str[$i].'/';
	}
	
	if($anlegen and !is_dir($dir)){
		$dir = PFAD_BILDER.'alben';
		for($i=0;$i<$anz;$i++){
			$dir .= '/'.$str[$i];
			if(is_dir($dir)){
				continue;
			}
			mkdir($dir);
			chmod($dir, 0777);
		}
		$dir .= '/';
	}
	return $dir;
}
	
	

}
# Ende der Klasse, EOF
?>