<?php

class dateien {

var $_tmpl;
var $_db;
var $verzeichnisse;
var $dateitypen = array(
	'gif' => array('image/gif','gif-Bild (.gif)'), # .......................................... Bilder
	'jpg' => array('image/jpeg','jpg-Bild (.jpg)'),
	'png' => array('image/png','png-Bild (.png)'),
	'odt' => array('application/vnd.oasis.opendocument.text','OOo-Writer-Dokument (.odt)'),# .. Office-Dokumente
	'ods' => array('application/vnd.oasis.opendocument.spreadsheet','OOo-Calc-Dokument (.ods)'),
	'doc' => array('application/msword','M$-Word-Dokument (.doc)'),
	'xls' => array('application/msexcel','M$-Excel-Dokument (.xls)'),
	'txt' => array('text/plain','Text-Datei (.txt)'), # ....................................... Text-Dateien
	'ini' => array('text/plain','Einstellungs-Datei (.ini)'),
	'csv' => array('text/comma-separated-values','csv-Datei (.csv)'),
	'rtf' => array('application/rtf','rtf-Dokument (.rtf)'),
	'dsv' => array('text/x-dsvdatei','dsv-Datei (.dsv)'),
	'lxf' => array('application/x-lenex','Lenex-Datei (.lxf)'), # ............................. gepackte Dateien
	'zip' => array('application/zip','zip-Archiv (.zip)'),
	'rar' => array('application/x-rar-compressed','rar-Archiv (.rar)'),
	'html' => array('text/html','html-Datei (.html)'), # ...................................... Internet
	'pdf' => array('application/pdf','pdf-Datei (.pdf)') # .................................... Sonstiges
);

var $anpassungen = array( # Ziel => Quellen
	'html' => array('htm'),
	'jpg'  => array('jpeg', 'jpe'),
	'lxf'  => array('lef')
);

function dateien(&$_db, &$_tmpl, $verzeichnisseeinlesen = false){
	if(!empty($_db)){
		$this->db =& $_db;
	}
	if(!empty($_tmpl)){
		$this->tmpl =& $_tmpl;
	}
	if($verzeichnisseeinlesen){
		$this->verzeichnisseEinlesen();
	}
}

function legeDateiInWettkampfvereichnisAn($verzeichnisid, $dateiname, $dateitype, $daten, $beschreibung = '', $ueberschreiben = true){

	if(TKSWIM_SCHREIBSCHUTZ){
		trigger_error('[tkswim][class/dateien/legedateiinwettkampfverzeichnisan] Die Daten konnten wegen aktivierem Schreibschutz nicht gespeichert werden.', E_USER_ERROR);
	}
	if($ueberschreiben){
		$query = "SELECT id, systemname FROM ".DB_PREFIX."dateien
					WHERE dateiname = '".text_format($dateiname,'db')."' AND
					type = '".text_format($dateitype,'db')."' AND
					verzeichnisid = '".text_format($verzeichnisid,'db')."'";
		$this->db->holeDaten($query);
		if($this->db->holeAnzahl() == 1){
			$id = $this->db->holeWert('id');
			$systemname = $this->db->holeWert('systemname');
		}
		else{
			$systemname = $this->generiereDateiname($dateitype, PFAD_DATEIEN);
		}
	}
	else{
		$systemname = $this->generiereDateiname($dateitype, PFAD_DATEIEN);
	}

	# Datei anlegen/leeren
	$fh = fopen(PFAD_DATEIEN.$systemname,'w');
	if(!$fh){
		return false;
	}
	fwrite($fh,$daten,strlen($daten));
	fclose($fh);
	$beschreibung = (string)$beschreibung==1?'':(string)$beschreibung;
	if(isset($id)){
		$query = "UPDATE ".DB_PREFIX."dateien SET letzteaenderung = NOW(), groesse = ".strlen($daten)." WHERE id = ".$id."";
	}
	else{
		$query = "INSERT INTO ".DB_PREFIX."dateien SET
					angelegt        = NOW(),
					letzteaenderung = NOW(),
					userid          = ".$_SESSION['user']['id'].",
					gruppenid       = 5,
					rechte          = 'rwxrw-r--',
					dateiname       = '".$dateiname."',
					typ             = '".$dateitype."',
					systemname      = '".$systemname."',
					groesse         = ".strlen($daten).",
					verzeichnisid   = ".$verzeichnisid.",
					beschreibung    = '".text_format($beschreibung,'db')."'";
	}
	$this->db->fuehreQueryAus($query);

	# Daten in DB schreiben
	return true;
}

function legeDateiInHomevereichnisAn($dateiname, $dateitype, $daten, $beschreibung = ''){
	$systemname = $this->generiereDateiname($dateitype, PFAD_DATEIEN);

	# Datei anlegen
	$fh = fopen(PFAD_DATEIEN.$systemname,'w');
	if(!$fh){
		return false;
	}
	fwrite($fh,$daten,strlen($daten));
	fclose($fh);
	$beschreibung = (string)$beschreibung==1?'':(string)$beschreibung;
	# Daten in DB schreiben
	$query = "INSERT INTO ".DB_PREFIX."dateien SET
				angelegt        = NOW(),
				letzteaenderung = NOW(),
				userid          = ".$_SESSION['user']['id'].",
				gruppenid       = 5,
				rechte          = 'rwx------',
				dateiname       = '".$dateiname."',
				typ             = '".$dateitype."',
				systemname      = '".$systemname."',
				groesse         = ".strlen($daten).",
				verzeichnisid   = ".$_SESSION['user']['homeverzeichnis'].",
				beschreibung    = '".text_format($beschreibung,'db')."'";
	$this->db->fuehreQueryAus($query);
	return true;
}

function baueFormularrechte($dbstring){
	$rechte = array(
		'u' => array('r' => false, 'w' => false, 'x' => false),
		'g' => array('r' => false, 'w' => false, 'x' => false),
		'o' => array('r' => false, 'w' => false, 'x' => false)
	);
	if($dbstring[0] == 'r'){ $rechte['u']['r'] = true; }
	if($dbstring[1] == 'w'){ $rechte['u']['w'] = true; }
	if($dbstring[2] == 'x'){ $rechte['u']['x'] = true; }
	if($dbstring[3] == 'r'){ $rechte['g']['r'] = true; }
	if($dbstring[4] == 'w'){ $rechte['g']['w'] = true; }
	if($dbstring[5] == 'x'){ $rechte['g']['x'] = true; }
	if($dbstring[6] == 'r'){ $rechte['o']['r'] = true; }
	if($dbstring[7] == 'w'){ $rechte['o']['w'] = true; }
	if($dbstring[8] == 'x'){ $rechte['o']['x'] = true; }
	return $rechte;
}

function baueDetailrechte($dbstring, $art){
	$rechtetexte = array(
		'datei' => array(
			'r' => 'anzeigen',
			'w' => 'bearbeiten',
			'x' => 'löschen'
		),
		'verzeichnis' => array(
			'r' => 'Inhalte anzeigen',
			'w' => 'Inhalte bearbeiten',
			'x' => 'ändern'
		)
	);

	$rechte = array(
		'u' => array('r' => false, 'w' => false, 'x' => false),
		'g' => array('r' => false, 'w' => false, 'x' => false),
		'o' => array('r' => false, 'w' => false, 'x' => false)
	);

	if($dbstring[0] == 'r'){ $rechte['u']['r'] = true; }
	if($dbstring[1] == 'w'){ $rechte['u']['w'] = true; }
	if($dbstring[2] == 'x'){ $rechte['u']['x'] = true; }
	if($dbstring[3] == 'r'){ $rechte['g']['r'] = true; }
	if($dbstring[4] == 'w'){ $rechte['g']['w'] = true; }
	if($dbstring[5] == 'x'){ $rechte['g']['x'] = true; }
	if($dbstring[6] == 'r'){ $rechte['o']['r'] = true; }
	if($dbstring[7] == 'w'){ $rechte['o']['w'] = true; }
	if($dbstring[8] == 'x'){ $rechte['o']['x'] = true; }
	
	$texte = array();
	foreach($rechte as $gr => $gruppe){
		foreach($gruppe as $recht => $da){
			if(!$da){
				continue;
			}
			if(!isset($texte[$gr])){
				$texte[$gr] = array();
			}
			$texte[$gr][] = $rechtetexte[$art][$recht];
		}
	}	
	$texte['u'] = isset($texte['u'])?implode(', ',$texte['u']):'-';
	$texte['g'] = isset($texte['g'])?implode(', ',$texte['g']):'-';
	$texte['o'] = isset($texte['o'])?implode(', ',$texte['o']):'-';
	return $texte;
}

function verzeichnisseEinlesen(){
	$query = "SELECT id, userid, gruppenid, rechte, name, parentid FROM ".DB_PREFIX."verzeichnisse ORDER BY name";
	$this->db->holeDaten($query);
	foreach($this->db->ergebnis['daten'] as $row){
		$this->verzeichnisse[$row['id']] = $row;
		$this->verzeichnisse[$row['id']]['eigenerechte'] = $this->ermittleRechte($row['rechte'],$row['userid'],$row['gruppenid']);
	}
}

function baueVerzeichnisListe($rootid = 0, $idweglassen = array()){
	if(is_null($this->verzeichnisse)){
		$this->verzeichnisseEinlesen();
	}
	$daten = array($rootid => 'root');
	$daten = $this->_baueVerzeichnisListe($daten, $rootid, 0, $idweglassen);
	return $daten;
}

function _baueVerzeichnisListe($daten, $parentid = 0, $ebene = 0, $idweglassen = array()){
	$ebene++;
	foreach($this->verzeichnisse as $row){
		if($row['parentid'] != $parentid){
			continue;
		}
		if(in_array($row['id'],$idweglassen)){
			continue;
		}
		if(!in_array('s_dateien_rootzugriff',$_SESSION['user']['rechte']) and $row['parentid']==1 and $row['id'] != $_SESSION['user']['homeverzeichnis']){
			continue;
		}
		$daten[$row['id']] = str_repeat('&nbsp;',$ebene*3).$row['name'];
		if($row['eigenerechte']['r'] or $row['name']=='home'){
			$daten = $this->_baueVerzeichnisListe($daten, $row['id'], $ebene, $idweglassen);
		}
	}
	return $daten;
}

function holeVerzeichnisseMitFehlendenRechten($verzeichnisse, $recht){
	if(is_null($this->verzeichnisse)){
		$this->verzeichnisseEinlesen();
	}
	$rechte = array();
	foreach($this->verzeichnisse as $key => $v){
		if(!$v['eigenerechte'][$recht]){
			$rechte[] = $key;
		}
	}
	return $rechte;
}

function holeVerzeichnisBaum($verzeichnisid, $links = true){
	if(is_null($this->verzeichnisse)){
		$this->verzeichnisseEinlesen();
	}
	$daten = $this->_holeVerzeichnisBaum($verzeichnisid);
	$baum = array();
	$ps = ROOT.'/sonstiges/dateien'.TKSWIM_DATEIENDUNG;
	$vr = prueferechte('s_dateien_rootzugriff')?0:$this->ermittleVerzeichnisRoot($verzeichnisid);
	$baum[] = $links?'<a href="'.$ps.'">'.($vr==0?'root':'home').'</a>':($vr==0?'root':'home');
	for($i=count($daten)-1;$i>=0;$i--){
		$baum[] = $links?'<a href="'.$ps.'?dir='.$daten[$i]['id'].'">'.$daten[$i]['name'].'</a>':$daten[$i]['name'];
	}
	return implode('/',$baum);
}

function _holeVerzeichnisBaum($verzeichnisid, $daten=array()){
	if($verzeichnisid == 0){
		return $daten;
	}
	if(!prueferechte('s_dateien_rootzugriff') and ($verzeichnisid == 1 or $verzeichnisid == $_SESSION['user']['homeverzeichnis'])){
		return $this->_holeVerzeichnisBaum($this->verzeichnisse[$verzeichnisid]['parentid'], $daten);
	}
	$row = $this->verzeichnisse[$verzeichnisid];
	$daten[] = array(
		'name'     => $row['name'],
		'parentid' => $row['parentid'],
		'id'       => $verzeichnisid
	);
	if($row['parentid'] == 0){
		return $daten;
	}
	else{
		return $this->_holeVerzeichnisBaum($row['parentid'], $daten);
	}
}

function ermittleRechte($rechte, $userid, $gruppenid){
	$rueckgabe = array(
		'r' => false,
		'w' => false,
		'x' => false
	);
	if(strlen($rechte) != 9 or !isset($_SESSION['eingelogt'])){
		return $rueckgabe;
	}
	if(prueferechte('s_dateien_rootzugriff')){
		$rueckgabe['r'] = true;
		$rueckgabe['w'] = true;
		$rueckgabe['x'] = true;
		return $rueckgabe;
	}
	if($userid == $_SESSION['user']['id']){
		if($rechte{0} == 'r'){
			$rueckgabe['r'] = true;
		}
		if($rechte{1} == 'w'){
			$rueckgabe['w'] = true;
		}
		if($rechte{2} == 'x'){
			$rueckgabe['x'] = true;
		}
	}
	if(in_array($gruppenid, $_SESSION['user']['rechtegruppen'])){
		if($rechte{3} == 'r'){
			$rueckgabe['r'] = true;
		}
		if($rechte{4} == 'w'){
			$rueckgabe['w'] = true;
		}
		if($rechte{5} == 'x'){
			$rueckgabe['x'] = true;
		}
	}
	if($rechte{6} == 'r'){
		$rueckgabe['r'] = true;
	}
	if($rechte{7} == 'w'){
		$rueckgabe['w'] = true;
	}
	if($rechte{8} == 'x'){
		$rueckgabe['x'] = true;
	}
	return $rueckgabe;
}

function schreibeTmpdateiInDb($tmpdatei, $daten=array()){
	if(isset($daten['zuueberschreibendeid'])){
		# angegebene ID ueberschreiben
		return;
	}
	$endung = substr($daten['dateiname'], strrpos($daten['dateiname'], '.')+1);
	$systemname = $this->generiereDateiname($endung, PFAD_DATEIEN);
	$query = "INSERT INTO ".DB_PREFIX."dateien
				(angelegt, letzteaenderung, userid, gruppenid,
				rechte, dateiname,
				systemname, groesse, verzeichnisid,
				beschreibung)
				VALUES (
				NOW(), NOW(), ".$daten['userid'].", ".$daten['gruppenid'].",
				'".$daten['rechte']."', '".text_format($daten['dateiname'],'db')."',
				'".$systemname."', '".filesize(PFAD_TMP.$tmpdatei)."',
				".$daten['verzeichnisid'].", '".text_format($daten['beschreibung'],'db')."')";
	$this->db->fuehreQueryAus($query);
	$kopiert = copy(PFAD_TMP.$tmpdatei, PFAD_DATEIEN.$systemname);
	if($kopiert){
		unlink(PFAD_TMP.$tmpdatei);
	}
	return;
}

function erzeugeTmpdatei($daten){
	$dateiname = $this->generiereDateiname('',PFAD_TMP);
	$fh = fopen(PFAD_TMP.$dateiname,'w');
	fwrite($fh,$daten,strlen($daten));
	fclose($fh);
	return $dateiname;
}

function sichereUploadDatei(){
	require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
	# Datei in tmp-Verzeichnis schieben
	$systemname = $this->generiereDateiname('', PFAD_TMP);
	move_uploaded_file($_FILES['datei']['tmp_name'],PFAD_TMP.$systemname);
	# Eintrag in dateien_tmp.ini generieren
	$dateiname = str_replace(' ','_',strtolower($_FILES['datei']['name']));
	$dateiname = preg_replace('~[^0-9a-z._-]~','',$dateiname);
	$inieintrag = time().'|'.$_SESSION['user']['id'].'|'.$dateiname;
	# dateien_tmp.ini schreiben
	$iniinhalt = parse_ini_file(PFAD_INIDATEIEN.'dateien_tmp.ini',false);
	$iniinhalt[$systemname] = $inieintrag;
	schreibe_ini_datei(PFAD_INIDATEIEN.'dateien_tmp.ini',$iniinhalt,false);
	return $systemname;
}

function generiereDateiname($endung, $verzeichnis=PFAD_DATEIEN){
	if(!is_dir($verzeichnis)){
		return false;
	}
	if(!empty($endung)){
		$endung = '.'.(in_array($endung,array_keys($this->dateitypen))?$endung:'tk');
	}
	$dateiname = md5(mt_rand().microtime().mt_rand()).$endung;
	while(file_exists($verzeichnis.$dateiname)){
		$dateiname = md5(mt_rand().microtime().mt_rand()).$endung;
	}
	return $dateiname;
}

function validiereDateidaten(&$daten, $dateidaten){
	require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
	$f = '';
	# der Besitzer (und root) darf die Rechte und das Verzeichnis aendern
	if($dateidaten['userid'] == $_SESSION['user']['id'] or prueferechte('s_dateien_rootzugriff')){
		$r = '';
		$r .= isset($_POST['formularrechte']['u']['r'])?'r':'-';
		$r .= isset($_POST['formularrechte']['u']['w'])?'w':'-';
		$r .= isset($_POST['formularrechte']['u']['x'])?'x':'-';
		$r .= isset($_POST['formularrechte']['g']['r'])?'r':'-';
		$r .= isset($_POST['formularrechte']['g']['w'])?'w':'-';
		$r .= isset($_POST['formularrechte']['g']['x'])?'x':'-';
		$r .= isset($_POST['formularrechte']['o']['r'])?'r':'-';
		$r .= isset($_POST['formularrechte']['o']['w'])?'w':'-';
		$r .= isset($_POST['formularrechte']['o']['x'])?'x':'-';
		$daten['originalrechte'] = $r;
		$tmp = pruefen($daten['verzeichnis'],'ungleich','Das Verzeichnis fehlt','-');
		if(empty($tmp)){
			if($daten['verzeichnis'] != 0){
				if(is_null($this->verzeichnisse)){
					$this->verzeichnisseEinlesen();
				}
				$verzeichnisse = array_keys($this->verzeichnisse);
				$f .= pruefen($daten['verzeichnis'],'wertemenge','Das Verzeichnis ist ungültig',$verzeichnisse);
				if(empty($f) and !$this->verzeichnisse[$daten['verzeichnis']]['eigenerechte']['w']){
					$f .= 'Das Verzeichnis ist ungültig.<br />';
				}
			}
			elseif(!prueferechte('s_dateien_rootzugriff')){
				$f .= 'Das Verzeichnis ist ungültig.<br />';
			}
		}
		else{
			$f .= $tmp;
		}
		if(!empty($f)){
			$daten['verzeichnis'] = $dateidaten['verzeichnis'];
		}
	}
	else{
		$daten['verzeichnis'] = $dateidaten['verzeichnis'];
		$daten['rechte'] = $dateidaten['rechte'];
	}

	# mit w-Rechten duerfen dateiname, type und beschreibung geaendert werden
	if($dateidaten['rechte']['w']){
		$f .= pruefen($daten['name'],'leer','Der Dateiname fehlt');
		$f .= pruefen($daten['name'],'minlaenge','Der Dateiname muss mindestens 2 Zeichen lang sein',2);
		$f .= pruefen($daten['name'],'maxlaenge','Der Dateiname darf höchstens 50 Zeichen lang sein',50);
		$f .= pruefen($daten['typ'],'leer','Der Dateitype fehlt');
		$tmp = pruefen($daten['typ'],'ungleich','Der Dateitype fehlt','-');
		if(empty($tmp)){
			$f .= pruefen($daten['typ'],'wertemenge','Der Dateitype ist ungültig.',array_keys($this->dateitypen));
		}
		else{
			$f .= $tmp;
		}
		$f .= pruefen($daten['beschreibung'],'maxlaenge','Die Beschreibung darf höchstens 65000 Zeichen lang sein',65000);
	}
	else{
		$daten['name'] = $dateidaten['name'];
		$daten['type'] = $dateidaten['type'];
		$daten['beschreibung'] = $dateidaten['beschreibung'];
	}

	# nur root darf userid und gruppenid aendern
	if(prueferechte('s_dateien_rootzugriff') or $_GET['aktion'] == 'verschieben'){
		$useridok = $parentidok = true;
		if(prueferechte('s_dateien_rootzugriff')){
			# Userid pruefen
			if(ctype_digit($daten['userid'])){
				$query = "SELECT id FROM ".DB_PREFIX."mitglieder WHERE ausgetreten IS NULL AND id = ".$daten['userid']."";
				$this->db->holeDaten($query);
				if($this->db->holeAnzahl() != 1){
					$useridok = false;
				}
			}
			else{
				$useridok = false;
			}
			if(!$useridok){
				$f .= 'Der User ist ungültig<br />';
			}
		}
		else{
			$daten['userid'] = $dateidaten['userid'];
		}
		# Gruppenid pruefen
		if(ctype_digit($daten['gruppenid'])){
			$query = "SELECT id FROM ".DB_PREFIX."rechtegruppen WHERE id = ".$daten['gruppenid']."";
			$this->db->holeDaten($query);
			if($this->db->holeAnzahl() != 1){
				$parentidok = false;
			}
		}
		else{
			$parentidok = false;
		}
		if(!$parentidok){
			$f .= 'Die Gruppe ist ungültig<br />';
		}
	}
	else{
		$daten['userid'] = $dateidaten['userid'];
		$daten['gruppenid'] = $dateidaten['gruppenid'];
	}

	return $f;
}

function speichereDateidaten($dateidaten, $daten, $art){
	if($art=='update'){
		$felder = array();
		$felder[] = "letzteaenderung = NOW()";
		if(isset($daten['userid']) and prueferechte('s_dateien_rootzugriff')){
			$felder[] = "userid = ".$daten['userid'];
		}
		if(isset($daten['gruppenid']) and prueferechte('s_dateien_rootzugriff')){
			$felder[] = "gruppenid = ".$daten['gruppenid'];
		}
		if(isset($daten['originalrechte']) and ($dateidaten['userid'] == $_SESSION['user']['id'] or prueferechte('s_dateien_rootzugriff'))){
			$felder[] = "rechte = '".$daten['originalrechte']."'";
		}
		if(isset($daten['name']) and $dateidaten['rechte']['w']){
			$felder[] = "dateiname = '".text_format($daten['name'],'db')."'";
		}
		if(isset($daten['typ']) and $dateidaten['rechte']['w']){
			$felder[] = "typ = '".$daten['typ']."'";
		}
		if(isset($daten['dateiersetzen']) and $daten['dateiersetzen'] != '-'){
			$felder[] = "groesse = '".$daten['groesse']."'";
		}
		if(isset($daten['verzeichnis']) and ($dateidaten['userid'] == $_SESSION['user']['id'] or prueferechte('s_dateien_rootzugriff'))){
			$felder[] = "verzeichnisid = ".$daten['verzeichnis'];
		}
		if(isset($daten['beschreibung']) and $dateidaten['rechte']['w']){
			$felder[] = "beschreibung = '".text_format($daten['beschreibung'],'db')."'";
		}
		$query = "UPDATE ".DB_PREFIX."dateien SET ".implode(', ',$felder)." WHERE id = ".$daten['id']."";
	}
	elseif($art=='insert'){
		$felder = array();
		$_dbdaten = array();
		$felder[]  = 'angelegt';
		$_dbdaten[] = 'NOW()';
		$felder[]  = 'letzteaenderung';
		$_dbdaten[] = 'NOW()';
		if(isset($daten['userid'])){
			$felder[]  = 'userid';
			$_dbdaten[] = $daten['userid'];
		}
		if(isset($daten['gruppenid'])){
			$felder[]  = 'gruppenid';
			$_dbdaten[] = $daten['gruppenid'];
		}
		if(isset($daten['originalrechte'])){
			$felder[]  = 'rechte';
			$_dbdaten[] = "'".$daten['originalrechte']."'";
		}
		if(isset($daten['name'])){
			$felder[]  = 'dateiname';
			$_dbdaten[] = "'".text_format($daten['name'],'db')."'";
		}
		if(isset($daten['typ'])){
			$felder[]  = 'typ';
			$_dbdaten[] = "'".$daten['typ']."'";
		}
		if(isset($daten['systemname'])){
			$felder[]  = 'systemname';
			$_dbdaten[] = "'".$daten['systemname']."'";
		}
		if(isset($daten['groesse'])){
			$felder[]  = 'groesse';
			$_dbdaten[] = "'".$daten['groesse']."'";
		}
		if(isset($daten['verzeichnis'])){
			$felder[]  = 'verzeichnisid';
			$_dbdaten[] = $daten['verzeichnis'];
		}
		if(isset($daten['beschreibung'])){
			$felder[]  = 'beschreibung';
			$_dbdaten[] = "'".text_format($daten['beschreibung'],'db')."'";
		}
		$query = "INSERT INTO ".DB_PREFIX."dateien (".implode(', ',$felder).")
					VALUES (".implode(', ',$_dbdaten).")";
	}
	else{
		return false;
	}
	if(isset($query)){
		$this->db->fuehreQueryAus($query);
		return true;
	}
	return false;
}

function speichereVerzeichnisdaten($verzeichnisdaten, $daten, $art){
	if($art=='update'){
		$felder = array();
		if(isset($daten['name']) and $verzeichnisdaten['rechte']['x']){
			$felder[] = "name = '".text_format($daten['name'],'db')."'";
		}
		if(isset($daten['parentid']) and $verzeichnisdaten['rechte']['x']){
			$felder[] = "parentid = ".$daten['parentid'];
		}
		if(isset($daten['userid']) and prueferechte('s_dateien_rootzugriff')){
			$felder[] = "userid = ".$daten['userid'];
		}
		if(isset($daten['gruppenid']) and prueferechte('s_dateien_rootzugriff')){
			$felder[] = "gruppenid = ".$daten['gruppenid'];
		}
		if(isset($daten['originalrechte']) and ($verzeichnisdaten['userid'] == $_SESSION['user']['id'] or prueferechte('s_dateien_rootzugriff'))){
			$felder[] = "rechte = '".$daten['originalrechte']."'";
		}
		if(count($felder) > 0){
			$query = "UPDATE ".DB_PREFIX."verzeichnisse SET ".implode(', ',$felder)." WHERE id = ".$daten['id']."";
		}
	}
	elseif($art=='insert'){
		$felder = array();
		$_dbdaten = array();
		if(isset($daten['name'])){
			$felder[]  = 'name';
			$_dbdaten[] = "'".text_format($daten['name'],'db')."'";
		}
		if(isset($daten['parentid'])){
			$felder[]  = 'parentid';
			$_dbdaten[] = $daten['parentid'];
		}
		if(isset($daten['userid'])){
			$felder[]  = 'userid';
			$_dbdaten[] = $daten['userid'];
		}
		if(isset($daten['gruppenid'])){
			$felder[]  = 'gruppenid';
			$_dbdaten[] = $daten['gruppenid'];
		}
		if(isset($daten['originalrechte'])){
			$felder[]  = 'rechte';
			$_dbdaten[] = "'".$daten['originalrechte']."'";
		}
		$query = "INSERT INTO ".DB_PREFIX."verzeichnisse (".implode(', ',$felder).")
					VALUES (".implode(', ',$_dbdaten).")";
	}
	else{
		return false;
	}
	if(isset($query)){
		$this->db->fuehreQueryAus($query);
		return true;
	}
	return false;
}

function holeRechtegruppen($smartyuebergeben = false){
	$query = "SELECT id, bezeichnung FROM ".DB_PREFIX."rechtegruppen ORDER BY sort";
	$this->db->holeDaten($query);
	$gruppen = $this->db->baueArray('bezeichnung','id');
	if($smartyuebergeben){
		$this->tmpl->assign('gruppen',$gruppen);
	}
	return $gruppen;
}

function holeUser($smartyuebergeben = false){
	$query = "SELECT id, CONCAT(nachname,', ',vorname) as name FROM ".DB_PREFIX."mitglieder
				WHERE ausgetreten IS NULL ORDER BY nachname, vorname";
	$this->db->holeDaten($query);
	$user = $this->db->baueArray('name','id');
	if($smartyuebergeben){
		$this->tmpl->assign('user',$user);
	}
	return $user;
}

function ermittleVerzeichnisRoot($verzeichnisid){
	# gibt entweder 0 (=rootverzeichnis) oder die id des homeverzeichnisses zurueck
	if(is_null($this->verzeichnisse)){
		$this->verzeichnisseEinlesen();
	}
	if($verzeichnisid == 0){
		return 0;
	}
	while(true){
		$parentid = $this->verzeichnisse[$verzeichnisid]['parentid'];
		if($parentid == 0){
			return 0;
		}
		if($parentid == 1){
			return $verzeichnisid;
		}
		$verzeichnisid = $parentid;
	}
}

function _holeVerzeichnisdaten($id){
	if(!$this->_pruefeAufGueltigeId($id,'dir')){
		return false;
	}
	$query = "SELECT rechte, userid, gruppenid, id, name, parentid
				FROM ".DB_PREFIX."verzeichnisse WHERE id = ".$id."";
	$this->db->holeDaten($query);
	return $this->db->holeZeile();
}

function validiereVerzeichnisdaten(&$daten, $verzeichnisdaten){
	require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
	$f = '';
	# mit x-Rechten duerfen parentid und name geaendert werden
	if($verzeichnisdaten['rechte']['x']){
		$tmp = pruefen($daten['parentid'],'ungleich','Das Eltern-Verzeichnis fehlt','-');
		if(empty($tmp)){
			if($daten['parentid'] != 0){
				if(is_null($this->verzeichnisse)){
					$this->verzeichnisseEinlesen();
				}
				$verzeichnisse = array_keys($this->verzeichnisse);
				$f .= pruefen($daten['parentid'],'wertemenge','Das Eltern-Verzeichnis ist ungültig',$verzeichnisse);
				if(empty($f) and !$this->verzeichnisse[$daten['parentid']]['eigenerechte']['w']){
					$f .= 'Das Eltern-Verzeichnis ist ungültig.<br />';
				}
				if($daten['parentid'] == $verzeichnisdaten['id']){
					$f .= 'Das Eltern-Verzeichnis ist ungültig.<br />';
				}
				else{
					$pid = $daten['parentid'];
					while($this->verzeichnisse[$pid]['parentid'] != 0){
						if($this->verzeichnisse[$pid]['parentid'] == $verzeichnisdaten['id']){
							$f = 'Das Eltern-Verzeichnis ist ungültig.<br />';
							break;
						}
						$pid = $this->verzeichnisse[$pid]['parentid'];
					}
				}
			}
		}
		else{
			$f .= $tmp;
		}
		if(!empty($f)){
			$daten['parentid'] = $verzeichnisdaten['parentid'];
		}
		$f .= pruefen($daten['name'],'leer','Der Verzeichnisname fehlt');
		$f .= pruefen($daten['name'],'minlaenge','Der Verzeichnisname muss mindestens 2 Zeichen lang sein',2);
		$f .= pruefen($daten['name'],'maxlaenge','Der Verzeichnisname darf höchstens 50 Zeichen lang sein',50);
		$f .= pruefen($daten['name'],'regexpr','Der Verzeichnisname ist ungültig (nur die Zeichen [a-z0-9_-])','^[a-z0-9_-]+$');
	}
	else{
		$daten['name'] = $verzeichnisdaten['name'];
		$daten['parentid'] = $verzeichnisdaten['parentid'];
	}

	# der Besitzer (und root) darf die Rechte aendern
	if($verzeichnisdaten['userid'] == $_SESSION['user']['id'] or prueferechte('s_dateien_rootzugriff')){
		$r = '';
		$r .= isset($_POST['formularrechte']['u']['r'])?'r':'-';
		$r .= isset($_POST['formularrechte']['u']['w'])?'w':'-';
		$r .= isset($_POST['formularrechte']['u']['x'])?'x':'-';
		$r .= isset($_POST['formularrechte']['g']['r'])?'r':'-';
		$r .= isset($_POST['formularrechte']['g']['w'])?'w':'-';
		$r .= isset($_POST['formularrechte']['g']['x'])?'x':'-';
		$r .= isset($_POST['formularrechte']['o']['r'])?'r':'-';
		$r .= isset($_POST['formularrechte']['o']['w'])?'w':'-';
		$r .= isset($_POST['formularrechte']['o']['x'])?'x':'-';
		$daten['originalrechte'] = $r;
	}
	else{
		$daten['rechte'] = $verzeichnisdaten['rechte'];
	}

	# nur root darf userid und gruppenid aendern
	if(prueferechte('s_dateien_rootzugriff')){
		$useridok = $parentidok = true;
		# Userid pruefen
		if(ctype_digit($daten['userid'])){
			$query = "SELECT id FROM ".DB_PREFIX."mitglieder WHERE ausgetreten IS NULL AND id = ".$daten['userid']."";
			$this->db->holeDaten($query);
			if($this->db->holeAnzahl() != 1){
				$useridok = false;
			}
		}
		else{
			$useridok = false;
		}
		if(!$useridok){
			$f .= 'Der User ist ungültig<br />';
		}
		# Gruppenid pruefen
		if(ctype_digit($daten['gruppenid'])){
			$query = "SELECT id FROM ".DB_PREFIX."rechtegruppen WHERE id = ".$daten['gruppenid']."";
			$this->db->holeDaten($query);
			if($this->db->holeAnzahl() != 1){
				$parentidok = false;
			}
		}
		else{
			$parentidok = false;
		}
		if(!$parentidok){
			$f .= 'Die Gruppe ist ungültig<br />';
		}
	}
	else{
		$daten['userid'] = $verzeichnisdaten['userid'];
		$daten['gruppenid'] = $verzeichnisdaten['gruppenid'];
	}

	return $f;
}

function _pruefeAufGueltigeId($id,$filedir){
	if(!ctype_digit($id)){
		return false;
	}
	$tabelle = $filedir=='dir'?'verzeichnisse':'dateien';
	$query = "SELECT name FROM ".DB_PREFIX.$tabelle." WHERE id = ".$id."";
	$this->db->holeDaten($query);
	return ($this->db->ergebnis['anzahl']==1)?true:false;
}

}# Ende der Klasse, EOF
?>