<?php


class dsv {

var $daten;

function leseDateiEin($datei, $ergebnisse = '*'){
	# Bestimmen welche Art die Datei enthält und die entsprechende Methode aufrufen
	if(file_exists($datei)){
		$_inhalt = file_get_contents($datei);
		$_inhalt = utf8_encode($_inhalt);
	}
	else{
		return false;
	}

	# Kommentare entfernen
	$_inhalt = preg_replace('~\(\*.*?\*\)~s','',$_inhalt);
	# Dateiart bestimmen
	$pos = strpos($_inhalt,':');
	$art = trim(strtolower(substr($_inhalt,0,$pos)));

	if($ergebnisse == 'art'){
		return $art;
	}

	switch($art){
	case 'vereinsmeldeliste':
		$ergebnis = array('art' => 'vereinsmeldeliste');
		break;
	case 'vereinsergebnisliste':
		$ergebnis = $this->_parseVereinsergebnisliste($_inhalt, $ergebnisse);
		break;
	case 'wettkampfergebnisliste':
		$ergebnis = $this->_parsewettkampfergebnisliste($_inhalt, $ergebnisse);
		break;
	case 'wettkampfdefinitionsliste':
		$ergebnis = $this->_parsewettkampfdefinitionsliste($_inhalt, $ergebnisse);
		break;
	default:
		return false;
		break;
	}
	if(in_array($art, array('vereinsergebnisliste', 'wettkampfergebnisliste')) and isset($ergebnis['wettkaempfe']) and count($ergebnis['wettkaempfe'])>0){
		$wknr = array_keys($ergebnis['wettkaempfe']);
		$this->daten = $ergebnis;
		$this->daten['ergebnisse'] = array();
		foreach($wknr as $nr){
			if(isset($ergebnis['ergebnisse'][$nr])){
				$this->daten['ergebnisse'][$nr] = $ergebnis['ergebnisse'][$nr];
			}
		}
	}
	elseif(in_array($art, array('vereinsmeldeliste', 'wettkampfdefinitionsliste'))){
		$this->daten = $ergebnis;
	}
	return true;
}


function _parsewettkampfdefinitionsliste($daten, $ergebnisse = '*'){
	$erg = array();
	$erg['art'] = 'wettkampfdefinitionsliste';
	# Ueberschrift, Dateiende
	$daten = str_replace('WETTKAMPFDEFINITIONSLISTE:','',$daten);
	$daten = str_replace('DATEIENDE','',$daten);
	# Format
	preg_match('~\s*FORMAT\s*:\s*(4|5)\s*;\s*(?:(ANSI|IBM)\s*;)?\s*~',$daten,$match);
	$erg['format'] = $match[1];
	$daten = str_replace($match[0],'',$daten);
	# Veranstaltung
	$regex = '~\s*VERANSTALTUNG\s*:\s*([^;]+)\s*;\s*([^;]+)\s*;(?:\s*(25|50|X)\s*;?\s*(HANDZEIT|AUTOMATISCH)\s*;)?\s*~';
	preg_match($regex, $daten, $match);
	$erg['veranstaltung'] = array(
		'bezeichnung' => $match[1],
		'ort' => $match[2],
		'bahnlaenge' => isset($match[3])?$match[3]:'',
		'zeitmessung' => isset($match[4])?$match[4]:'',
	);
	$daten = str_replace($match[0], '', $daten);

	# Veranstaltungsort
	$regex = '~\s*VERANSTALTUNGSORT\s*:\s*([^;]*)\s*;\s*([^;]*)\s*;\s*([^;]*)\s*;\s*([^;]*)\s*;\s*([^;]*)\s*;\s*([^;]*)\s*;\s*([^;]*)\s*;\s*([^;]*)\s*;\s*~';
	preg_match($regex, $daten, $match);
	$erg['veranstaltungsort'] = array(
		'bad'     => $match[1],
		'strasse' => $match[2],
		'plz'     => $match[3],
		'ort'     => $match[4],
		'land'    => $match[5],
		'telefon' => $match[6],
		'fax'     => $this->_sinnloserWert($match[7], 'fax')?'':$match[7],
		'email'   => $match[8]
	);
	$daten = str_replace($match[0], '', $daten);

	# Internetseite
	$regex = '~\s*AUSSCHREIBUNGIMNETZ\s*:\s*([^;]*)\s*;\s*~';
	$anz = preg_match($regex, $daten, $match);
	$erg['internetausschreibung'] = false;
	if($anz > 0){
		$erg['internetausschreibung'] = $this->_sinnloserWert($match[1])?false:$match[1];
		$daten = str_replace($match[0], '', $daten);
	}

	# Meldeadresse
	$regex = '~\s*MELDEADRESSE\s*:\s*([^;]*)\s*;\s*([^;]*)\s*;\s*([^;]*)\s*;\s*([^;]*)\s*;\s*([^;]*)\s*;\s*([^;]*)\s*;\s*([^;]*)\s*;\s*([^;]*)\s*;\s*~';
	preg_match($regex, $daten, $match);
	$erg['meldeadresse'] = array(
		'name'    => $match[1],
		'strasse' => $match[2],
		'plz'     => $match[3],
		'ort'     => $match[4],
		'land'    => $match[5],
		'telefon' => $match[6],
		'fax'     => $this->_sinnloserWert($match[7], 'fax')?'':$match[7],
		'email'   => $match[8]
	);
	$daten = str_replace($match[0], '', $daten);

	# Meldeschluss
	$regex = '~MELDESCHLUSS\s*:\s*(\d{2}\.\d{2}\.\d{4})\s*;\s*(\d{2}:\d{2})\s*;\s*~';
	preg_match($regex, $daten, $match);
	$erg['meldeschluss'] = array(
		'datum'   => $match[1],
		'uhrzeit' => $match[2]
	);
	$daten = str_replace($match[0], '', $daten);

	# Besonderes
	$regex = '~BESONDERES\s*:\s*([^;]*);\s*~';
	$anz = preg_match($regex, $daten, $match);
	$erg['besonderes'] = false;
	if($anz > 0){
		$erg['besonderes'] = $this->_sinnloserWert($match[1], 'besonderes')?false:$match[1];
		$daten = str_replace($match[0], '', $daten);
	}

	# Abschnitte
	$regex = '~ABSCHNITT\s*:\s*(\d+)\s*;\s*(\d{2}\.\d{2}\.\d{4})\s*;\s*((?:\d{2})?:(?:\d{2})?)?\s*;\s*';
	$regex .= '(?:EINLASS\s*:\s*(\d{2}:\d{2})\s*;\s*)?~'; # Einlass (in der aktuellen Version des dsv-Standards nicht mehr enthalten)
	preg_match_all($regex, $daten, $match);
	$erg['abschnitte'] = array();
	foreach($match[1] as $key => $abschn){
		$erg['abschnitte'][(int)$abschn] = array(
			'datum' => $match[2][$key],
			'zeit'  => $this->_sinnloserWert($match[3][$key], 'abschnittsbeginn')?false:$match[3][$key],
			'einlass' => !empty($match[4][$key])?$match[4][$key]:false
		);
	}
	$daten = str_replace($match[0],'',$daten);

	# Wettkaempfe
	$regex = '~WETTKAMPF\s*:\s*(\d+)\s*;\s*(?:(V|Z|F|A|E|N)?\s*;\s*)?(\d+)\s*;\s*((?:\d{1,2}\s*[*x]\s*)?\d{1,5})\s*(F|R|B|S|L|X)\s*(W|M|X)\s*;\s*(?:(SW|MS|FS)\s*;\s*)?~';
	$disziplinumsetzung = array(
		'F' => 1,
		'R' => 3,
		'B' => 2,
		'S' => 4,
		'L' => 5,
		'X' => 6
	);
	preg_match_all($regex, $daten, $match);
	$erg['wettkaempfe'] = array();
	# die Arrays $staffeln und $einzel dienen dazu um später zu wissen welcher Wettkampf ein Staffel- und welcher ein Einzelwettkampf ist
	$_staffel = $_einzel = array();
	foreach($match[1] as $key => $wk){
		$erg['wettkaempfe'][$wk] = array(
			'nr'     => $match[1][$key],
			'wkart'  => $match[2][$key],
			'abschn' => (int)$match[3][$key],
			'laenge' => str_replace(' ', '', $match[4][$key]),
			'lage'   => $disziplinumsetzung[$match[5][$key]],
			'mw'     => strtolower($match[6][$key]),
			'jahrgaenge' => '*'
		);
		if($match[4][$key]{1} == 'x' or ((strlen($match[4][$key])>2) and $match[4][$key]{2} == 'x')){
			$_staffel[] = $wk;
		}
		else{
			$_einzel[] = $wk;
		}
	}
	$daten = str_replace($match[0],'',$daten);

	# Wertungen
	$regex = '~(?:WERTUNG|Wertung)\s*:\s*(\d+)\s*;\s*(?:[VZFAEN]?\s*;\s*)?(?:((?:JG\s*:\s*\d+\s*(?:-\s*\d+)?)|(?:\s*AK\s*:\s*(?:\d+|J|A|B|C|D|E)))\s*;\s*)?(?:PFLICHTZEIT\s*:\s*([0-9]{1,2}:\d{2},\d{2})\s*;\s*)?~';
	preg_match_all($regex, $daten, $match);
	$daten = str_replace($match[0],'',$daten);
	$wertungen = array();
	foreach($match[1] as $key => $wk){
		if(!isset($wertungen[$wk])){
			$wertungen[$wk] = array();
		}
		$wertungen[$wk][] = array(
			'klasse' => $match[2][$key],
			'pflichtzeit' => $match[3][$key]
		);
	}
	$wkjahr = substr($erg['abschnitte']['1']['datum'],-4);
	foreach($wertungen as $wk => $w){
		$wert = $this->_parseWertungen($w, $wkjahr);
		$erg['wettkaempfe'][$wk]['jahrgaenge'] = $wert['jahrgaenge'];
		if($wert['pflichtzeiten'] !== false){
			if(!isset($erg['pflichtzeiten'])){
				$erg['pflichtzeiten'] = array();
			}
			$erg['pflichtzeiten'][$wk] = $wert['pflichtzeiten'];
		}
	}

	# Meldegeld
	$erg['meldegeld'] = array();
	# Meldegeldpauschale
	$regex = '~MELDEGELDPAUSCHALE\s*:\s*(\d{1,},\d{2})\s*;\s*~';
	$anz = preg_match($regex, $daten, $match);
	if($anz > 0){
		$daten = str_replace($match[0],'',$daten);
		$erg['meldegeld']['meldegeldpauschale'] = $match[1];
	}
	# Einzelmeldegeld
	$regex = '~EINZELMELDEGELD\s*:\s*(\d{1,},\d{2})\s*;\s*~';
	$anz = preg_match($regex, $daten, $match);
	if($anz > 0){
		$daten = str_replace($match[0],'',$daten);
		$erg['meldegeld']['einzelmeldegeld'] = $match[1];
	}
	# Staffelmeldegeld
	$regex = '~STAFFELMELDEGELD\s*:\s*(\d{1,},\d{2})\s*;\s*~';
	$anz = preg_match($regex, $daten, $match);
	if($anz > 0){
		$daten = str_replace($match[0],'',$daten);
		$erg['meldegeld']['staffelmeldegeld'] = $match[1];
	}
	# WK-Meldegeld (abweichendes Meldegeld für einzelne Wettkämpfe
	$regex = '~WKMELDEGELD\s*:\s*(\d+)\s*;\s*(\d{1,},\d{2})\s*;\s*~';
	$anz = preg_match_all($regex, $daten, $match);
	if($anz > 0){
		$daten = str_replace($match[0],'',$daten);
		$wkmeldegeld = array();
		foreach($match[1] as $key => $wk){
			$wkmeldegeld[$wk] = $match[2][$key];
		}
		$betraege = array();
		if(!isset($erg['meldegeld']['staffelmeldegeld'])){ # häufigsten Betrag bei den Staffeln ermitteln und verwenden
			$betraege = array();
			foreach($_staffel as $wknr){
				if(!isset($wkmeldegeld[$wknr])){
					continue;
				}
				$betrag = $wkmeldegeld[$wknr];
				if(!isset($betraege[$betrag])){
					$betraege[$betrag] = 1;
				}
				else{
					$betraege[$betrag]++;
				}
			}
			arsort($betraege);
			list($staffel,) = each($betraege);
			$erg['meldegeld']['staffelmeldegeld'] = $staffel;
			foreach($wkmeldegeld as $wk => $betrag){
				if(!in_array($wk, $_staffel)){
					continue;
				}
				if($betrag != $staffel){
					$erg['meldegeld']['wkmeldegeld'][$wk] = $betrag; 
				}
				else{
					unset($wkmeldegeld[$wk]);
				}
			}
		}
		else{
			foreach($wkmeldegeld as $wk => $betrag){
				if(!in_array($wk, $_staffel)){
					continue;
				}
				if($betrag != $erg['meldegeld']['staffelmeldegeld']){
					$erg['meldegeld']['wkmeldegeld'][$wk] = $betrag; 
				}
				
			}
		}
		
		if(!isset($erg['meldegeld']['einzelmeldegeld'])){ # häufigsten Betrag bei den Einzelstarts ermitteln und verwenden
			$betraege = array();
			foreach($_einzel as $wknr){
				if(!isset($wkmeldegeld[$wknr])){
					continue;
				}
				$betrag = $wkmeldegeld[$wknr];
				if(!isset($betraege[$betrag])){
					$betraege[$betrag] = 1;
				}
				else{
					$betraege[$betrag]++;
				}
			}
			arsort($betraege);
			list($einzel,) = each($betraege);
			$erg['meldegeld']['einzelmeldegeld'] = $einzel;


			foreach($wkmeldegeld as $wk => $betrag){
				if(!in_array($wk, $_einzel)){
					continue;
				}
				if($betrag != $einzel){
					$erg['meldegeld']['wkmeldegeld'][$wk] = $betrag; 
				}
				else{
					unset($wkmeldegeld[$wk]);
				}
			}
		}
		else{
			foreach($wkmeldegeld as $wk => $betrag){
				if(!in_array($wk, $_einzel)){
					continue;
				}
				if($betrag != $erg['meldegeld']['einzelmeldegeld']){
					$erg['meldegeld']['wkmeldegeld'][$wk] = $betrag; 
				}
				
			}
		}
	}

	# Ergebnisarray zurueckgeben
	return $erg;
}


function _parseWertungen($wertungen, $wkjahr){

	global $_altersklassen;
	$_pflichtzeiten = false;
	$_min = 9999;
	$_max = 0;

	foreach($wertungen as $key => $wertung){
		if(!empty($wertung['pflichtzeit'])){
			$_pflichtzeiten = true;
		}
		if($wertung['klasse'][0] == 'J'){ # Jahrgang
			$wert = trim(substr($wertung['klasse'],3));
			if(strpos($wert, '-') !== false){ # Bereich
				$teile = explode('-', $wert);
				$teile[0] = trim($teile[0]);
				$teile[1] = trim($teile[1]);
				$min = (int)min($teile);
				$max = (int)max($teile);
			}
			else{
				$min = $max = (int)$wert;
			}
		}
		else{ # AK
			$wert = trim(substr($wertung['klasse'],3));
			if(!in_array($wert, array('J','A','B','C','D','E'))){
				# Staffelalter -> ignorieren
				break;
			}
			else{
				if($wert == 'J'){
					$werte = $_altersklassen['junioren'];
				}
				else{
					$werte = $_altersklassen['j'.strtolower($wert)];
				}
				list($max, $min) = explode(',', $werte, 2);
				$min = $wkjahr-$min;
				$max = $wkjahr-$max;
			}
		}
		$wertungen[$key]['min'] = $min;
		$wertungen[$key]['max'] = $max;

		if($_min > $min){
			$_min = $min;
		}
		if($_max < $max){
			$_max = $max;
		}
	}

	if($_min <= ($wkjahr-95)){
		$_min = '';
	}
	if($_max >= $wkjahr){
		$_max = '';
	}

	if(empty($_min)){
		if(empty($_max)){ # offene Wertung
			$_jahrg = '*';
		}
		else{ # X und älter
			if($_max == ($wkjahr-20)){ # Masters
				$_jahrg = 'ak20+';
			}
			else{
				$_jahrg = $_max.'+';
			}
		}
	}
	elseif(empty($_max)){ # X und jünger
		$_jahrg = $_min.'-';
	}
	else{ # X bis Y
		$_jahrg = $_max.'-'.$_min;
	}

	if(!$_pflichtzeiten){
		return array('jahrgaenge' => $_jahrg, 'pflichtzeiten' => false);
	}

	$pflichtzeiten = array();
	$_ak = array();
	foreach($_altersklassen as $key => $alter){
		$teile = explode(',', $alter);
		$min = $wkjahr-max($teile);
		$max = $wkjahr-min($teile);
		$_ak[$key] = array('min' => $min, 'max' => $max);
	}

	foreach($wertungen as $wertung){
		$key = '*';
		if($wertung['min'] == $wertung['max']){ # ein Jahrgang
			$key = $wertung['min'];
		}
		elseif(empty($wertung['min'])){
			if(empty($wertung['max'])){ # offene Wertung
				$key = '*';
			}
			else{ # X und älter
				if($wertung['max'] == ($wkjahr-20)){ # Masters
					$key = 'ak20+';
				}
				else{
					$key = $wertung['max'].'+';
				}
			}
		}
		elseif(empty($wertung['min'])){ # X und jünger
			$key = $wertung['min'].'-';
		}
		else{ # X bis Y
			# auf einzelne Altersgruppen prüfen (mehrere Altersklassen und/oder Jahrgänge werden nicht
			#   unterstützt, wenn das aufteten sollte, wird die offene Wertung verwendet.)
			foreach($_ak as $ak => $jg){
				if($wertung['min'] != $jg['min'] or $wertung['min'] != $jg['min']){
					continue;
				}
				$key = $ak;
				break;
			}
		}
		if(empty($wertung['pflichtzeit'])){
			continue;
		}
		$pflichtzeiten[$key] = $wertung['pflichtzeit'];
	}
	return array('jahrgaenge' => $_jahrg, 'pflichtzeiten' => $pflichtzeiten);
}


function _sinnloserWert($wert, $art = ''){
	# erkennt sinnlose Werte (wie »???« oder »kein fax«)
	if($wert != '0' and empty($wert)){
		return true;
	}

	if($art == 'dsvid'){
		if($wert == '0' or $wert == '000000' or $wert == '999999'){
			return true;
		}
		else{
			return false;
		}
	}

	if($art == 'fax' and strtolower($wert) == 'kein fax'){
		return true;
	}

	if($art == 'abschnittsbeginn' and (trim($wert) == ':' or $wert == '00:00')){
		return true;
	}

	$laenge = strlen($wert);
	$gleichezeichen = true;
	for($i=0;$i<$laenge;$i++){
		if($wert[0] != $wert[$i]){
			$gleichezeichen = false;
		}
	}

	if($laenge >=2 and $gleichezeichen){
		return true;
	}

	return false;
}


function _parseVereinsergebnisliste($daten, $ergebnisse = '*'){
	$erg = array();
	$erg['art'] = 'vereinsergebnisliste';
	# Ueberschrift, Dateiende
	$daten = str_replace('VEREINSERGEBNISLISTE:','',$daten);
	$daten = str_replace('DATEIENDE','',$daten);
	# Format
	preg_match('~\s*FORMAT\s*:\s*(4|5)\s*;\s*(?:(ANSI|IBM)\s*;)?\s*~',$daten,$match);
	$erg['format'] = $match[1];
	$daten = str_replace($match[0],'',$daten);
	# Veranstaltung
	$regex = '~\s*VERANSTALTUNG\s*:\s*([^;]+)\s*;\s*([^;]+)\s*;\s*(25|50|X)\s*;\s*(HANDZEIT|AUTOMATISCH)\s*;~';
	preg_match($regex, $daten, $match);
	if(isset($match[1])){
		$erg['veranstaltung'] = array(
			'bezeichnung' => $match[1],
			'ort' => $match[2],
			'bahnlaenge' => $match[3],
			'zeitmessung' => $match[4]
		);
	}
	else{
		$erg['veranstaltung'] = array(
			'bezeichnung' => '[unbekannt]',
			'ort' => '',
			'bahnlaenge' => '',
			'zeitmessung' => ''
		);
	}
	$daten = str_replace($match[0], '', $daten);
	# Veranstalter, Ausrichter, Absender
	$regex = '~\s*VERANSTALTER\s*:\s*([^;]+)\s*;\s*AUSRICHTER\s*:\s*([^;]+)\s*;'; # Veranstalter, Absender
	$regex .= '\s*([^;]*)\s*;\s*([^;]*)\s*;\s*([^;]*)\s*;\s*([^;]*)\s*;\s*([^;]*)\s*;\s*([^;]*)\s*;\s*([^;]*)\s*;\s*([^;]*)\s*;\s*~'; # Adresse
	preg_match($regex, $daten, $match);
	$erg['veranstalter'] = $match[1];
	$erg['ausrichter'] = $match[2];
	$erg['absender'] = array(
		'name' => $match[3],
		'strasse' => $match[4],
		'plz' => $match[5],
		'ort' => $match[6],
		'land' => $match[7],
		'telefon' => $match[8],
		'fax' => $match[9],
		'email' => $match[10]
	);
	$daten = str_replace($match[0], '', $daten);
	# Abschnitte
	preg_match_all('~ABSCHNITT\s*:\s*(\d+)\s*;\s*(\d{2}\.\d{2}\.\d{4})\s*;\s*(\d{2}:\d{2})?\s*;~',$daten,$match);
	$erg['abschnitte'] = array();
	foreach($match[1] as $key => $abschn){
		$erg['abschnitte'][$abschn] = array(
			'datum' => $match[2][$key],
			'zeit'  => $match[3][$key]
		);
	}
	$daten = str_replace($match[0],'',$daten);
	$daten = trim($daten);
	# Wettkaempfe
	$regex = '~WETTKAMPF\s*:\s*(\d+)\s*;\s*(V|Z|F|A|E|N)?\s*;\s*(\d+)\s*;\s*((?:\d{1,2}x)?\d{1,5})\s*(F|R|B|S|L|X)\s*(W|M|X)\s*;';
	if($erg['format'] == '5'){
		$regex .= '\s*(SW|MS|FS)\s*;';
	}
	$regex .= '\s*~';
	$disziplinumsetzung = array(
		'F' => 1,
		'R' => 3,
		'B' => 2,
		'S' => 4,
		'L' => 5,
		'X' => 6
	);
	preg_match_all($regex,$daten,$match);
	$erg['wettkaempfe'] = array();
	$staffeln = array();
	$einzel = array();
	foreach($match[1] as $key => $wk){
		$erg['wettkaempfe'][$wk] = array(
			'nr'     => $match[1][$key],
			'art'    => $match[2][$key],
			'abschn' => $match[3][$key],
			'laenge' => $match[4][$key],
			'lage'   => $disziplinumsetzung[$match[5][$key]],
			'mw'     => strtolower($match[6][$key])
		);
		if($match[4][$key]{1} == 'x' or ((strlen($match[4][$key])>2) and $match[4][$key]{2} == 'x')){
			$staffeln[] = $wk;
		}
		else{
			$einzel[] = $wk;
		}
		if($erg['format'] == '5'){
			$erg['wettkaempfe'][$wk]['blzuordn'] = $match[7][$key];
		}
	}
	$daten = str_replace($match[0],'',$daten);
	$daten = trim($daten);
	
	if($ergebnisse == 'meta'){
		return $erg;
	}
	
	# Verein
	if($erg['format'] == '4'){
		$regex = '~VEREIN\s*:\s*([^;]+)\s*;\s*LSV\s*:\s*(\d{1,2})\s*;\s*NATION\s*:\s*([A-Z]{3})\s*;\s*~';
		preg_match($regex,$daten,$match);
		$erg['vereinsbezeichnung'][1] = array(
			'name'           => trim($match[1]),
			'landeschwverb'  => trim($match[2]),
			'finanatkuerzel' => trim($match[3])
		);
	}
	elseif($erg['format'] == '5'){
		$regex = '~VEREIN(?:SBEZEICHNUNG)?\s*:\s*([^;]+)\s*;\s*VNKENNZAHL\s*:\s*(\d{1,4})\s*;\s*LSV\s*:\s*(\d{1,2})\s*;\s*NATION\s*:\s*([A-Z]{3})\s*;\s*~';
		preg_match($regex,$daten,$match);
		$match[1] = trim($match[1]);
		$erg['vereinsbezeichnung'][1] = array(
			'name'           => trim($this->_entferneNl($match[1])),
			'vnkennzahl'     => $match[2],
			'landeschwverb'  => $match[3],
			'finanatkuerzel' => $match[4]
		);
	}
	$daten = str_replace($match[0],'',$daten);

	# Personenergebnisse
	$regex_pers = '\s*([^;]+)\s*;\s*([0-9]*)\s*;\s*(M|W)\s*;\s*(\d{1,4})\s*;\s*(\d*)\s*;\s*';
	$regex_zeit = '(?:\s*(?:\d{1,2}:\d{2},\d{2}\s*;)|(?:\d{1,2}h\d{2}:\d{2}(?:,\d{2})*\s*;))';
	if($erg['format'] == '5'){
		$regex_endzeit = substr($regex_zeit,0,-1).'\s*(?:REKORD\s*:\s*D[JM]?R\s*;)?\s*)';
	}
	else{
		$regex_endzeit = $regex_zeit;
	}
	$regex_erg = '(?:WK\s*:\s*\d*\s*;\s*[V|Z|F|A|E|N]\s*;\s*(?:\d*|DS|NA|AB|AU|ZU)\s*;\s*'.$regex_zeit.'*\s*'.$regex_endzeit.'\s*(?:DSBEM\s*:\s*[^;]*\s*;\s*)?\s*)';
	$regex = '~PNERGEBNIS\s*:'.$regex_pers.'('.$regex_erg.'*)\s*~';
	preg_match_all($regex, $daten, $match);
	$erg['ergebnisse'] = array();
	$regex_erg2 = '(?:WK\s*:\s*(\d*)\s*;\s*([V|Z|F|A|E|N])\s*;\s*(\d*|DS|NA|AB|AU|ZU)\s*;\s*('.$regex_zeit.'*)\s*('.$regex_zeit.')\s*';
	$regex_erg2 .= '(?:DSBEM\s*:\s*([^;]*)\s*;\s*)?\s*)';
	foreach($match[0] as $key => $pers){
		$mitgl = array(
			'platz' => '',
			'name' => trim($match[1][$key]),
			'dsvid' => $this->_sinnloserWert($match[2][$key], 'dsvid')?'':$match[2][$key],
			'mw' => strtolower($match[3][$key]),
			'jahrg' => $match[4][$key],
			'alterskl' => $match[5][$key],
			'verein' => 1,
			'zwischenzeiten' => array(),
			'endzeit' => '',
			'dsbem' => ''
		);
		preg_match_all('~'.$regex_erg2.'~',$match[6][$key],$match_e);
		foreach($match_e[0] as $key2 => $ergebn){
			if(!isset($erg['ergebnisse'][$match_e[1][$key2]])){
				$erg['ergebnisse'][$match_e[1][$key2]] = array();
			}
			if(!isset($erg['ergebnisse'][$match_e[1][$key2]][$match_e[2][$key2]])){
				$erg['ergebnisse'][$match_e[1][$key2]][$match_e[2][$key2]] = array();
			}
			$tmp = $mitgl;
			$tmp['platz'] = $match_e[3][$key2];
			$tmp['zwischenzeiten'] = explode(';',substr($match_e[4][$key2],0,-1));
			$tmp['endzeit'] = substr($match_e[5][$key2],0,-1);
			$tmp['dsbem'] = preg_replace("/(\015\012)|(\015)|(\012)|( {2,})/",' ',trim($match_e[6][$key2]));
			$erg['ergebnisse'][$match_e[1][$key2]][$match_e[2][$key2]][] = $tmp;
		}
		$daten = str_replace($pers,'',$daten);
	}
	# Staffelergebnisse
	$regex = '~STERGEBNIS\s*:\s*(\d+)\s*;\s*((?:(?:JG:\d+(?:-\d+)?)|(?:AK:(?:\d+\+?|J|A|B|C|D|E)))?)\s*;\s*'; # Staffeldaten
	$regex .= '((?:WK\s*:\s*\d*\s*;\s*[V|Z|F|A|E|N]\s*;\s*(?:\d*|DS|NA|AB|AU|ZU)\s*;';
	$regex .= ''.$regex_zeit.'*\s*'.$regex_endzeit.'\s*'; # Zeiten
	$regex .= '(?:\s*[^;]+\s*;\s*[0-9]*\s*;\s*(?:M|W)\s*;\s*\d{1,4}\s*;\s*\d*\s*;\s*)*'; # Personen
	$regex .= '\s*(?:DSBEM\s*:\s*[^;]+\s*;\s*)?)*)'; # dsbem
	$regex .= '\s*~s';
	preg_match_all($regex, $daten, $match);
	foreach($match[3] as $key => $wk){
		$staffel = array(
			'platz' => '',
			'mannschaft' => $match[1][$key],
			'staffelklasse' => $match[2][$key],
			'verein' => 1,
			'zwischenzeiten' => array(),
			'endzeit' => '',
			'schwimmer' => array(),
			'dsbem' => ''
		);
		$regex2 = '~WK\s*:\s*(\d*)\s*;\s*([V|Z|F|A|E|N])\s*;\s*(\d*|DS|NA|AB|AU|ZU)\s*;';
		$regex2 .= '('.$regex_zeit.'*)\s*('.$regex_zeit.')\s*'; # Zeiten
		$regex2 .= '((?:\s*[^;]+\s*;\s*[0-9]*\s*;\s*(?:M|W)\s*;\s*\d{1,4}\s*;\s*\d*\s*;\s*)*)\s*'; # Personen
		$regex2 .= '\s*((?:DSBEM\s*:\s*[^;]+\s*;\s*)?)\s*~'; # dsbem
		preg_match_all($regex2, $wk, $match2);
		foreach($match2[6] as $key2 => $pers){
			$tmp = $staffel;
			$tmp['platz'] = $match2[3][$key2];
			$tmp['zwischenzeiten'] = explode(';',substr($match2[4][$key2],0,-1));
			$tmp['zwischenzeiten'] = array_map('trim',$tmp['zwischenzeiten']);
			$tmp['endzeit'] = substr($match2[5][$key2],0,-1);
			$tmp['dsbem'] = preg_replace("/(\015\012)|(\015)|(\012)|( {2,})/",' ',trim($match2[7][$key2]));
			$regex3 = '~\s*([^;]+)\s*;\s*([0-9]*)\s*;\s*(M|W)\s*;\s*(\d{1,4})\s*;\s*(\d*)\s*;\s*~'; # Personen
			preg_match_all($regex3, $pers, $match3);
			foreach($match3[1] as $key3 => $name){
				$tmp['schwimmer'][] = array(
					'name'     => trim($name),
					'dsvid'    => $this->_sinnloserWert($match3[2][$key3], 'dsvid')?'':$match3[2][$key3],
					'mw'       => strtolower($match3[3][$key3]),
					'jahrg'    => $match3[4][$key3],
					'alterskl' => $match3[5][$key3],
				);
			}
			if(!isset($erg['ergebnisse'][$match2[1][$key2]])){
				$erg['ergebnisse'][$match2[1][$key2]] = array();
			}
			if(!isset($erg['ergebnisse'][$match2[1][$key2]][$match2[2][$key2]])){
				$erg['ergebnisse'][$match2[1][$key2]][$match2[2][$key2]] = array();
			}
			$erg['ergebnisse'][$match2[1][$key2]][$match2[2][$key2]][] = $tmp;
		}
	}
	# Ergebnisarray zurueckgeben
	return $erg;
	
}


function _entferneNl($wert){
	return trim(preg_replace('~\s+~',' ',$wert));
}


function _parsewettkampfergebnisliste($daten, $ergebnisse = '*'){
	$erg = array();
	$erg['art'] = 'wettkampfergebnisliste';
	# Ueberschrift, Dateiende
	$daten = str_replace('WETTKAMPFERGEBNISLISTE:','',$daten);
	$daten = str_replace('DATEIENDE','',$daten);
	# Format
	preg_match('~\s*FORMAT\s*:\s*(4|5)\s*;\s*(?:(ANSI|IBM)\s*;)?\s*~',$daten,$match);
	$erg['format'] = $match[1];
	$daten = str_replace($match[0],'',$daten);
	# Veranstaltung
	$regex = '~\s*VERANSTALTUNG\s*:\s*([^;]+)\s*;\s*([^;]+)\s*;\s*(25|50|X)\s*;\s*(HANDZEIT|AUTOMATISCH)\s*;~';
	preg_match($regex, $daten, $match);
	if(isset($match[1])){
		$erg['veranstaltung'] = array(
			'bezeichnung' => $match[1],
			'ort' => $match[2],
			'bahnlaenge' => $match[3],
			'zeitmessung' => $match[4]
		);
	}
	else{
		$erg['veranstaltung'] = array(
			'bezeichnung' => '[unbekannt]',
			'ort' => '',
			'bahnlaenge' => '',
			'zeitmessung' => ''
		);
	}
	$daten = preg_replace($regex, '', $daten);
	# Veranstalter, Ausrichter, Absender
	$regex = '~\s*VERANSTALTER\s*:\s*([^;]+)\s*;\s*AUSRICHTER\s*:\s*([^;]+)\s*;'; # Veranstalter, Absender
	$regex .= '\s*([^;]*)\s*;\s*([^;]*)\s*;\s*([^;]*)\s*;\s*([^;]*)\s*;\s*([^;]*)\s*;\s*([^;]*)\s*;\s*([^;]*)\s*;\s*([^;]*)\s*;\s*~'; # Adresse
	preg_match($regex, $daten, $match);
	$erg['veranstalter'] = isset($match[1])?$match[1]:'';
	$erg['ausrichter'] = isset($match[2])?$match[2]:'';
	if(isset($match[3])){
		$erg['absender'] = array(
			'name'    => $match[3],
			'strasse' => $match[4],
			'plz'     => $match[5],
			'ort'     => $match[6],
			'land'    => $match[7],
			'telefon' => $match[8],
			'fax'     => $match[9],
			'email'   => $match[10]
		);
	}
	else{
		$erg['absender'] = array(
			'name'    => '',
			'strasse' => '',
			'plz'     => '',
			'ort'     => '',
			'land'    => '',
			'telefon' => '',
			'fax'     => '',
			'email'   => ''
		);
	}

	$daten = preg_replace($regex, '', $daten);
	# Abschnitte
	preg_match_all('~ABSCHNITT\s*:\s*(\d+)\s*;\s*(\d{2}\.\d{2}\.\d{4})\s*;\s*(\d{2}:\d{2})?\s*;~',$daten,$match);
	$erg['abschnitte'] = array();
	foreach($match[1] as $key => $abschn){
		$erg['abschnitte'][$abschn] = array(
			'datum' => $match[2][$key],
			'zeit'  => $match[3][$key]
		);
	}
	$daten = str_replace($match[0],'',$daten);
	$daten = trim($daten);
	# Wettkaempfe
	$regex = '~WETTKAMPF\s*:\s*(\d+)\s*;\s*(V|Z|F|A|E|N)?\s*;\s*(\d+)\s*;\s*((?:\d{1,2}x)?\d{1,5})\s*(F|R|B|S|L|X)\s*(W|M|X)\s*;';
	if($erg['format'] == '5'){
		$regex .= '\s*(SW|MS|FS)\s*;';

	}
	$regex .= '\s*~';
	$disziplinumsetzung = array(
		'F' => 1,
		'R' => 3,
		'B' => 2,
		'S' => 4,
		'L' => 5,
		'X' => 6
	);
	preg_match_all($regex,$daten,$match);
	$erg['wettkaempfe'] = array();
	$staffeln = array();
	$einzel = array();
	foreach($match[1] as $key => $wk){
		if($match[4][$key] == 0 and $match[5][$key] == 0){
			continue;
		}
		$erg['wettkaempfe'][$wk] = array(
			'nr'     => $match[1][$key],
			'art'    => $match[2][$key],
			'abschn' => $match[3][$key],
			'laenge' => $match[4][$key],
			'lage'   => $disziplinumsetzung[$match[5][$key]],
			'mw'     => strtolower($match[6][$key])
		);
		if($match[4][$key]{1} == 'x' or ((strlen($match[4][$key])>2) and $match[4][$key]{2} == 'x')){
			$staffeln[] = $wk;
		}
		else{
			$einzel[] = $wk;
		}
		if($erg['format'] == '5'){
			$erg['wettkaempfe'][$wk]['blzuordn'] = $match[7][$key];
		}
	}
	$daten = str_replace($match[0],'',$daten);
	$daten = trim($daten);
	
	if($ergebnisse == 'meta'){
		return $erg;
	}

	# Vereinsbezeichnung
	$erg['vereinsbezeichnung'] = array();
	$vereine = array();
	$i = 1;
	if($erg['format'] == '4'){
		$regex = '~VEREINSBEZEICHNUNG\s*:\s*([^;]+)\s*;\s*LSV\s*:\s*(\d{1,2})\s*;\s*NATION\s*:\s*([A-Z]{3})\s*;\s*~';
		preg_match_all($regex,$daten,$match);
		foreach($match[1] as $key => $vn){

			$vereine[$match[1][$key]] = $i;
			$erg['vereinsbezeichnung'][$i] = array(
				'name'           => $match[1][$key],
				'landeschwverb'  => $match[2][$key],
				'finanatkuerzel' => $match[3][$key]
			);
			$i++;
		}
	}
	elseif($erg['format'] == '5'){
		$regex = '~VEREIN(?:SBEZEICHNUNG)?\s*:\s*([^;]+)\s*;\s*VNKENNZAHL\s*:\s*(\d{1,4})\s*;\s*LSV\s*:\s*([^;]+)?\s*;\s*NATION\s*:\s*([A-Z]{3})\s*;\s*~';
		preg_match_all($regex,$daten,$match);
		foreach($match[1] as $key => $vn){
			$match[1][$key] = trim($match[1][$key]);
			$vereine[$match[1][$key]] = $i;
			$erg['vereinsbezeichnung'][$i] = array(
				'name'           => $this->_entferneNl($match[1][$key]),
				'vnkennzahl'     => $match[2][$key],
				'landeschwverb'  => ((strlen($match[3][$key])==2 and ctype_digit($match[3][$key]))?$match[3][$key]:''),
				'finanatkuerzel' => $match[4][$key]
			);
			$i++;
		}
	}
	$daten = str_replace($match[0],'',$daten);
	$daten = trim($daten);

	# Ergebnisse
	$ergebnisse = explode('WK:',$daten);
	unset($ergebnisse[0]);
	$erg['ergebnisse'] = array();
	$regex_zeit = '(?:(?:\d{1,2}:\d{2},\d{2}\s*;\s*)|(?:\d{1,2]h\d{2}:\d{2}(?:,\d{2})*\s*;\s*))';
	$regex_pers = '~\s*([^;]+)\s*;\s*([^;]*)\s*;\s*(M|W)\s*;\s*(\d{1,4})\s*;\s*(\d*)\s*;\s*~';
	if($erg['format'] == '4'){
		foreach($ergebnisse as $ergebnis){
			$regex = '~^\s*(\d+)\s*;\s*(V|Z|F|A|E|N)?\s*;\s*(.*)\s*$~s';
			preg_match($regex, $ergebnis, $match);
			if(!isset($erg['ergebnisse'][$match[1]])){
				$erg['ergebnisse'][$match[1]] = array();
			}
			if(empty($match[2])){
				$match[2] = '';
			}
			if(!isset($erg['ergebnisse'][$match[1]][$match[2]])){
				$erg['ergebnisse'][$match[1]][$match[2]] = array();
			}
			if(in_array($match[1], $staffeln)){ # Staffelergebnis
				if(empty($match[3])){
					continue;
				}
				$regex_s = '~(\d+|DS|NA|AB|AU|ZU)\s*;\s*(\d+)\s*;\s*((?:(?:JG:\s*\d+(?:-\d+)?)|(?:AK:\s*(?:\d+\+?|J|A|B|C|D|E)))?)\s*;\s*([^;]+)\s*;\s*';
				$regex_s .= '('.$regex_zeit.'*)\s*('.$regex_zeit.')\s*'; # Zeiten
				$regex_s .= '((?:\s*[^;]+\s*;\s*[^;]*\s*;\s*(?:M|W)\s*;\s*\d{1,4}\s*;\s*\d*\s*;\s*)*)'; # Personen
				$regex_s .= '\s*(?:DSBEM\s*:\s*([^;]+)\s*;\s*)?'; # dsbem
				$regex_s .= '\s*~s';
				preg_match_all($regex_s, $match[3], $match_s);
				foreach($match_s[1] as $key => $wk){
					$schwimmer = array();
					preg_match_all($regex_pers, $match_s[7][$key], $match_pers);
					foreach($match_pers[1] as $key_pers => $pers){
						$schwimmer[] = array(
							'name'     => trim($match_pers[1][$key_pers]),
							'dsvid'    => $this->_sinnloserWert($match_pers[2][$key_pers], 'dsvid')?'':$match_pers[2][$key_pers],
							'mw'       => strtolower($match_pers[3][$key_pers]),
							'jahrg'    => $match_pers[4][$key_pers],
							'alterskl' => $match_pers[5][$key_pers],
						);
					}
					$erg['ergebnisse'][$match[1]][$match[2]][] = array(
						'platz'          => $match_s[1][$key],
						'mannschaft'     => $match_s[2][$key],
						'staffelklasse'  => $match_s[3][$key],
						'verein'         => $vereine[$this->_entferneNl($match_s[4][$key])],
						'zwischenzeiten' => explode(';',substr($match_s[5][$key],0,-1)),
						'endzeit'        => substr($match_s[6][$key],0,-1),
						'schwimmer'      => $schwimmer,
						'dsbem'          => preg_replace("/(\015\012)|(\015)|(\012)/",' ',trim($match_s[8][$key]))
					);
				}
			}
			else{ # Einzelergebnis
				if(empty($match[3])){
					continue;
				}
				$regex_e = '~(\d+|DS|NA|AB|AU|ZU)\s*;\s*([^;]+)\s*;\s*([^;]*)\s*;\s*(M|W)\s*;\s*(\d{1,4})\s*;\s*(\d*)\s*;\s*([^;]+)\s*;\s*';
				$regex_e .= '('.$regex_zeit.'*)\s*('.$regex_zeit.')\s*'; # Zeiten
				$regex_e .= '\s*(?:DSBEM\s*:\s*([^;]+)\s*;\s*)?'; # dsbem
				$regex_e .= '\s*~';
				preg_match_all($regex_e, $match[3], $match_e);
				foreach($match_e[1] as $key => $wk){
					$erg['ergebnisse'][$match[1]][$match[2]][] = array(
						'platz'    => $match_e[1][$key],
						'name'     => trim($match_e[2][$key]),
						'dsvid'    => $this->_sinnloserWert($match_e[3][$key], 'dsvid')?'':$match_e[3][$key],
						'mw'       => strtolower($match_e[4][$key]),
						'jahrg'    => $match_e[5][$key],
						'alterskl' => $match_e[6][$key],
						'verein'   => $vereine[$this->_entferneNl($match_e[7][$key])],
						'zwischenzeiten' => explode(';',substr($match_e[8][$key],0,-1)),
						'endzeit'  => substr($match_e[9][$key],0,-1),
						'dsbem'    => preg_replace("/(\015\012)|(\015)|(\012)/",' ',trim($match_e[10][$key]))
					);
				}
			}
		}
	} # DSV-Format 4 - Ende
	elseif($erg['format'] == '5'){
		foreach($ergebnisse as $ergebnis){
			$regex = '~^\s*(\d+)\s*;\s*(V|Z|F|A|E|N)?\s*;\s*(.*)\s*$~s';
			preg_match($regex, $ergebnis, $match);
			if(!isset($erg['ergebnisse'][$match[1]])){
				$erg['ergebnisse'][$match[1]] = array();
			}
			if(empty($match[2])){
				$match[2] = '';
			}
			if(!isset($erg['ergebnisse'][$match[1]][$match[2]])){
				$erg['ergebnisse'][$match[1]][$match[2]] = array();
			}
			if(in_array($match[1], $staffeln)){ # Staffelergebnis
				if(empty($match[3])){
					continue;
				}
				$regex_s = '~(\d+|DS|NA|AB|AU|ZU)\s*;\s*(\d+)\s*;\s*((?:(?:JG:\s*\d+(?:-\d+)?)|(?:AK:\s*(?:\d+\+?|J|A|B|C|D|E)))?)\s*;\s*([^;]+)\s*;\s*(\d{1,4})\s*;\s*';
				$regex_s .= '('.$regex_zeit.'*)\s*('.$regex_zeit.')\s*(?:REKORD\s*:\s*(DR|DJR|DMR)\s*;\s*)?'; # Zeiten
				$regex_s .= '((?:\s*[^;]+\s*;\s*[0-9]*\s*;\s*(?:M|W)\s*;\s*\d{1,4}\s*;\s*\d*\s*;\s*)*)'; # Personen
				$regex_s .= '\s*(?:DSBEM\s*:\s*([^;]+)\s*;\s*)?'; # dsbem
				$regex_s .= '\s*~s';
				preg_match_all($regex_s, $match[3], $match_s);

				# Anzahl der Staffeln in der Wertung bestimmen
				$_anzahl = 0;
				foreach($match_s[1] as $platz){
					if(!in_array($platz,array('DS','NA','AB','AU'))){
						$_anzahl++;
					}
				}
				foreach($match_s[1] as $key => $wk){
					$schwimmer = array();
					preg_match_all($regex_pers, $match_s[9][$key], $match_pers);
					foreach($match_pers[1] as $key_pers => $pers){
						$schwimmer[] = array(
							'name'     => trim($match_pers[1][$key_pers]),
							'dsvid'    => $this->_sinnloserWert($match_pers[2][$key_pers], 'dsvid')?'':$match_pers[2][$key_pers],
							'mw'       => strtolower($match_pers[3][$key_pers]),
							'jahrg'    => $match_pers[4][$key_pers],
							'alterskl' => $match_pers[5][$key_pers],
						);
					}
					$zwzeiten = explode(';',substr($match_s[6][$key],0,-1));
					$anz = count($zwzeiten);
					for($i=0;$i<$anz;$i++){
						$zwzeiten[$i] = trim($zwzeiten[$i]);
					}
					$erg['ergebnisse'][$match[1]][$match[2]][] = array(
						'platz'          => $match_s[1][$key],
						'mannschaft'     => $match_s[2][$key],
						'staffelklasse'  => $match_s[3][$key],
						'verein'         => $vereine[$this->_entferneNl($match_s[4][$key])],
						'vereinid'       => $match_s[5][$key],
						'zwischenzeiten' => $zwzeiten,
						'endzeit'        => substr(trim($match_s[7][$key]),0,-1),
						'schwimmer'      => $schwimmer,
						'rekord'         => $match_s[8][$key],
						'dsbem'          => preg_replace("/(\015\012)|(\015)|(\012)/",' ',trim($match_s[10][$key])),
						'anzahl'         => $_anzahl
					);
				}
			}
			else{ # Einzelergebnis
				if(empty($match[3])){
					continue;
				}
				$regex_e = '~(\d+|DS|NA|AB|AU|ZU)\s*;\s*([^;]+)\s*;\s*([0-9]*)\s*;\s*(M|W)\s*;\s*(\d{1,4})\s*;\s*(\d*)\s*;\s*([^;]+)\s*;\s*(\d{1,4})\s*;\s*';
				$regex_e .= '('.$regex_zeit.'*)\s*('.$regex_zeit.')\s*(?:REKORD\s*:\s*(DR|DJR|DMR)\s*;\s*)?'; # Zeiten
				$regex_e .= '\s*(?:DSBEM\s*:\s*([^;]+)\s*;\s*)?'; # dsbem
				$regex_e .= '\s*~';
				preg_match_all($regex_e, $match[3], $match_e);
				# Anzahl der Teilnehmer in der Wertung bestimmen
				$_anzahl = 0;
				foreach($match_e[1] as $platz){
					if(!in_array($platz,array('DS','NA','AB','AU'))){
						$_anzahl++;
					}
				}
				foreach($match_e[1] as $key => $wk){
					$zwzeiten = explode(';',substr($match_e[9][$key],0,-1));
					$anz = count($zwzeiten);
					for($i=0;$i<$anz;$i++){
						$zwzeiten[$i] = trim($zwzeiten[$i]);
					}
					$erg['ergebnisse'][$match[1]][$match[2]][] = array(
						'platz'    => $match_e[1][$key],
						'name'     => trim($match_e[2][$key]),
						'dsvid'    => $this->_sinnloserWert($match_e[3][$key], 'dsvid')?'':$match_e[3][$key],
						'mw'       => strtolower($match_e[4][$key]),
						'jahrg'    => $match_e[5][$key],
						'alterskl' => $match_e[6][$key],
						'verein'   => $vereine[$this->_entferneNl($match_e[7][$key])],
						'vereinid' => $match_e[8][$key],
						'zwischenzeiten' => $zwzeiten,
						'endzeit'  => substr(trim($match_e[10][$key]),0,-1),
						'rekord'   => $match_e[11][$key],
						'dsbem'    => preg_replace("/(\015\012)|(\015)|(\012)/",' ',trim($match_e[12][$key])),
						'anzahl'   => $_anzahl
					);
				}
			}
		}
	} # DSV-Format 5 - Ende
	return $erg;
}

} # Ende der Klasse, EOF
?>