<?php
$updates['0.8.12'] = array(
	'dateienupdate' => array(
		'htaccess'	
	),
	'neuerechte' => array(
		'm_tools_mitgliederverschmelzen' => array(
			'sort' => '183',
			'bezeichnung' => 'Mitgliedertools - Mitglieder verschmelzen'
		)
	),
	'querys' => array(
		"UPDATE ".DB_PREFIX."mitglieder SET strasse = NULL WHERE strasse = ''",
		"UPDATE ".DB_PREFIX."mitglieder SET hausnr = NULL WHERE hausnr = ''",
		"UPDATE ".DB_PREFIX."mitglieder SET plz = NULL WHERE plz = ''",
		"UPDATE ".DB_PREFIX."mitglieder SET ort = NULL WHERE ort = ''",
		"UPDATE ".DB_PREFIX."mitglieder SET email = NULL WHERE email = ''",
		"UPDATE ".DB_PREFIX."mitglieder SET sonstiges = NULL WHERE sonstiges = ''",
		"ALTER TABLE ".DB_PREFIX."kampfrichter DROP id",
		"ALTER TABLE ".DB_PREFIX."kampfrichter CHANGE mitgliedid id SMALLINT(5) UNSIGNED NOT NULL",	
		"ALTER TABLE ".DB_PREFIX."kampfrichter ADD PRIMARY KEY (id)"
	),
	'kontrollquery' => "SELECT IF(COUNT(strasse)<1,1,0) as ok FROM ".DB_PREFIX."mitglieder WHERE strasse = ''",
	'funktion' => 'anfang'
);

function update_0_8_12(){
	# die Kampfrichter werden jetzt anhand ihrer Mitgliederid identifiziert
	#   die IDs in den Wettkampfabwickungsdateien müssen also umgeschrieben werden
	$dateien = glob(PFAD_INIDATEIEN.'wkabwickeln_*');
	require_once(PFAD_INCLUDE.'func/schreibe_ini_datei.inc.php');
	foreach($dateien as $datei){
		$inh = parse_ini_file($datei,true);
		if(!isset($inh['kampfrichter']) or count($inh['kampfrichter'])<1){
			continue;
		}
		$ids = array_keys($inh['kampfrichter']);		
		$query = "SELECT id, mitgliedid FROM ".DB_PREFIX."kampfrichter WHERE id IN (".implode(',',$ids).")";
		global $_db;
		$_db->holeDaten($query);
		$ersatz = $_db->baueArray('mitgliedid', 'id');
		$karialt = $inh['kampfrichter'];
		$inh['kampfrichter'] = array();
		foreach($karialt as $kariid => $abschn){
			if(!isset($ersatz[$kariid])){
				continue; # bei alten Wettkämpfen wenn Kampfrichter inzwischen gelöscht wurden -> ignorieren
			}
			$inh['kampfrichter'][$ersatz[$kariid]] = $abschn;
		}
		schreibe_ini_datei($datei, $inh, true);
	}

	return true;
}



# EOF
?>