<?php
$updates['0.8.13'] = array(
	'neuerechte' => array(
		'w_abwickeln_allebearbeiten' => array(
			'sort' => '425',
			'bezeichnung' => 'Wettkämpfe abwickeln - alle Wettkämpfe bearbeiten'
		),
		'w_abwickeln_eigenekarimeldung' => array(
			'sort' => '420',
			'bezeichnung' => 'Wettkämpfe abwickeln - Grundrechte (nur eigene Kampfrichtermeldung)'
		)
	),
	'neueeinstellungen' => array(
		'global' => array(
			array(
				'gruppe' => 'wettkaempfe_abwickeln',
				'einstellung' => 'trainingsgruppenwettkaempfe'
			)
		)
	),
	'querys' => array(
		"UPDATE ".DB_PREFIX."rechte SET sort = 421 WHERE id IN ('w_abwickeln_mitglhinzufuegen','w_abwickeln_meldezettel')",
		"UPDATE ".DB_PREFIX."rechte SET sort = 422 WHERE id IN ('w_abwickeln_ruecklaufzettel','w_abwickeln_kampfrichter','w_abwickeln_meldung')",
		"UPDATE ".DB_PREFIX."rechte SET sort = 423 WHERE id IN ('w_abwickeln_wettkampflisten')",
		"UPDATE ".DB_PREFIX."rechte SET sort = 424 WHERE id IN ('w_abwickeln_ergebnisse','w_abwickeln_bemerkungen')",
		"INSERT INTO ".DB_PREFIX."rechtegruppen SET id = 6, sort = 21, bezeichnung = 'Kampfrichter'",
		"INSERT INTO ".DB_PREFIX."rechtegruppen_mitglieder (rechtegrid, mitgliedid) 
			SELECT 6, k.id FROM ".DB_PREFIX."kampfrichter as k LEFT JOIN ".DB_PREFIX."logins as l ON k.id=l.id 
			WHERE anmeldename IS NOT NULL AND freigeschaltet = 1 AND gueltigbis >= YEAR(NOW())",
		"CREATE TABLE ".DB_PREFIX."trainingsgruppen_wettkaempfe (trainingsgruppenid TINYINT UNSIGNED NOT NULL, wettkampfid SMALLINT UNSIGNED NOT NULL) ENGINE = MYISAM"
	),
	'kontrollquery' => "SELECT IF(sort=425,0,1) as ok FROM ".DB_PREFIX."rechte WHERE id = 'w_abwickeln_meldung'",
	'funktion' => 'ende'
);

function update_0_8_13(){
	global $_db;
	# die IDs der Übungsleiter in der Verknüpfungstabelle zu den Trainingsgruppen anpassen und dann die Übungsleitertabelle ändern
	$query = "SELECT mitgliedid, trainingsgruppenid 
				FROM ".DB_PREFIX."uebungsleiter as u LEFT JOIN ".DB_PREFIX."trainingsgruppen_uebungsleiter as tu ON u.id = tu.uebungsleiterid
				WHERE trainingsgruppenid IS NOT NULL
				ORDER BY trainingsgruppenid, mitgliedid";
	$_db->holeDaten($query);
	$anzahl = $_db->holeAnzahl();
	$gruppenzuordungen = $_db->baueArray('*','#');
	$query = "ALTER TABLE ".DB_PREFIX."trainingsgruppen_uebungsleiter CHANGE uebungsleiterid uebungsleiterid SMALLINT UNSIGNED NOT NULL";
	$_db->fuehreQueryAus($query);
	if($anzahl>0){
		$query = "TRUNCATE TABLE ".DB_PREFIX."trainingsgruppen_uebungsleiter";
		$_db->fuehreQueryAus($query);
		$datensaetze = array();
		foreach($gruppenzuordungen as $row){
			$datensaetze[] = "(".$row['trainingsgruppenid'].", ".$row['mitgliedid'].")";
		}
		$query = "INSERT INTO ".DB_PREFIX."trainingsgruppen_uebungsleiter (trainingsgruppenid, uebungsleiterid) 
					VALUES ".implode(', ', $datensaetze);
		$_db->fuehreQueryAus($query);
	}
	$query = "ALTER TABLE ".DB_PREFIX."uebungsleiter DROP id";
	$_db->fuehreQueryAus($query);
	$query = "ALTER TABLE ".DB_PREFIX."uebungsleiter CHANGE mitgliedid id SMALLINT UNSIGNED NOT NULL";
	$_db->fuehreQueryAus($query);
	$query = "ALTER TABLE ".DB_PREFIX."uebungsleiter ADD PRIMARY KEY (id)";
	$_db->fuehreQueryAus($query);
}
# EOF
?>