<?php
$updates['0.9'] = array(
	'dateienupdate' => array(
		'htaccess',
		'config'
	),
	'neuerechte' => array(
		's_bilder_anzeigen' => array(
			'sort' => '651',
			'bezeichnung' => 'Bilder - anzeigen'
		),
		's_bilder_bearbeiten' => array(
			'sort' => '652',
			'bezeichnung' => 'Bilder - eigene bearbeiten'
		),
		's_bilder_allebearbeiten' => array(
			'sort' => '653',
			'bezeichnung' => 'Bilder - alle bearbeiten'
		),
		's_bilder_kommentarebearbeiten' => array(
			'sort' => '654',
			'bezeichnung' => 'Bilder - Kommentare bearbeiten'		
		),
		's_bilder_meldungenbearbeiten' => array(
			'sort' => '655',
			'bezeichnung' => 'Bilder - Meldungen bearbeiten'		
		)
	),
	'querys' => array(
		"ALTER TABLE ".DB_PREFIX."kampfrichter CHANGE gruppe gruppe VARCHAR(3) NOT NULL",
		"UPDATE ".DB_PREFIX."kampfrichter SET gruppe = '100' WHERE gruppe IN (1,2)",
		"UPDATE ".DB_PREFIX."kampfrichter SET gruppe = '110' WHERE gruppe = 3",
		"UPDATE ".DB_PREFIX."kampfrichter SET gruppe = '111' WHERE gruppe = 4",
		
		"CREATE TABLE ".DB_PREFIX."bilder_alben (id smallint(5) unsigned NOT NULL AUTO_INCREMENT, datum date NOT NULL, `name` varchar(100) NOT NULL, besitzer smallint(5) unsigned NOT NULL, angelegt datetime NOT NULL, PRIMARY KEY (id)) ENGINE=MyISAM",
		"CREATE TABLE ".DB_PREFIX."bilder_bilder (id mediumint(8) unsigned NOT NULL AUTO_INCREMENT, albumid smallint(5) unsigned NOT NULL, `name` varchar(50) NOT NULL, breite smallint(5) unsigned NOT NULL, hoehe smallint(5) unsigned NOT NULL, fotograf smallint(5) unsigned DEFAULT NULL, angelegt datetime NOT NULL, PRIMARY KEY (id)) ENGINE=MyISAM",
		"CREATE TABLE ".DB_PREFIX."bilder_kommentare (bildid mediumint(8) unsigned NOT NULL, autor smallint(5) unsigned NOT NULL, zeitpunkt datetime NOT NULL, `text` mediumtext NOT NULL, KEY bildid (bildid)) ENGINE=MyISAM",
		"CREATE TABLE ".DB_PREFIX."bilder_markierungen (bildid mediumint(8) unsigned NOT NULL, mid smallint(5) unsigned NOT NULL, pos_x smallint(5) NOT NULL, pos_y smallint(5) NOT NULL, KEY bildid (bildid)) ENGINE=MyISAM",		
		
		"ALTER TABLE ".DB_PREFIX."logins ADD letzterlogin DATETIME NULL DEFAULT NULL",
		"UPDATE ".DB_PREFIX."logins SET letzterlogin = NOW()",
			
		"INSERT INTO ".DB_PREFIX."rechtegruppen SET id = 7, sort = 22, bezeichnung = 'aktive Schwimmer'",
		"INSERT INTO ".DB_PREFIX."rechtegruppen_mitglieder (mitgliedid, rechtegrid) 
			SELECT DISTINCT mt.mitgliedid, 7 FROM ".DB_PREFIX."mitglieder_trainingsgruppen as mt LEFT JOIN ".DB_PREFIX."logins as l ON mt.mitgliedid=l.id 
			  WHERE anmeldename IS NOT NULL AND freigeschaltet = 1 ORDER BY mt.mitgliedid"
	),
	'hinweise' => array(
		'Nach dem Update muss der Pfad zu TCPDF gesetzt werden (Admininterface/Pfade einstellen; falls das entsprechende Modul installiert wurde, wird der Pfad automatisch gesetzt)'
	),
	'kontrollquery' => "SELECT 1 as ok FROM information_schema.COLUMNS WHERE TABLE_SCHEMA = '".DB_NAME."' AND TABLE_NAME = '".DB_PREFIX."kampfrichter' AND COLUMN_NAME = 'gruppe' AND DATA_TYPE = 'varchar'",
	'funktion' => 'anfang'
);

function update_0_9(){
	# Verzeichnis für die Alben anlegen
	mkdir(PFAD_HTTP.'__inc/bilder_speicher/alben');
	chmod(PFAD_HTTP.'__inc/bilder_speicher/alben', 0777);
	
	if(!defined('PFAD_TCPDF')){
		if(file_exists(PFAD_INCLUDE.'class/tcpdf/tcpdf.php')){
			define('PFAD_TCPDF', PFAD_INCLUDE.'class/tcpdf/');
		}
		else{
			define('PFAD_TCPDF', '');
		}
	}

	# diverse Dateien nach UTF8 konvertieren
	$dateien = glob(PFAD_INIDATEIEN.'*');
	$dateien = array_merge($dateien, glob(PFAD_LOGDATEIEN.'*'));
	$dateien = array_merge($dateien, array(PFAD_INCLUDE.'conf/conf.inc.php'));
	$dateien = array_merge($dateien, glob(PFAD_INCLUDE.'conf/*.ini'));
	foreach($dateien as $datei){
		$inhalt = file_get_contents($datei);
		if(strlen($inhalt)==0){
			continue;
		}
		$inhalt = utf8_encode($inhalt);
		file_put_contents($datei, $inhalt);	
	}
	
	# Datenbank nach UTF8 konvertieren
	#  Tabellen holen
	global $_db;
	$query = "SHOW TABLES FROM `".DB_NAME."` LIKE '".DB_PREFIX."%'";
	$_db->holeDaten($query, E_USER_ERROR, 'row');
	$tabellen = $_db->baueArray('0','#');
	#  Sicherung erstellen
	require_once(PFAD_INCLUDE.'class/zip.inc.php');
	$zip = new zipfile();
	$zip->addFile_daten($_db->exportiereDatenbank('', $tabellen), date('Y-m-d_H-i').'_'.substr(DB_PREFIX,0,-1).'.sql', time());
	$zip->speichereDatei(PFAD_INCLUDE.'sicherung/'.date('Y-m-d_H-i').'_datenbanksicherung-bei-update.zip');
	#  Tabellen konvertieren
	foreach($tabellen as $tabelle){
		$query = "ALTER TABLE ".$tabelle." CONVERT TO CHARACTER SET utf8 COLLATE utf8_general_ci";
		$_db->fuehreQueryAus($query);
	}
	
	return true;
}
# EOF
?>