<?php
$_usereinstellungen_module = array(
	'globaleeinstellungen' => array(
		'recht'        => '*',
		'titel'        => 'globale Einstellungen',
		'beschreibung' => 'globale Optionen für die Seite'
	),
	'emailbenachrichtigung' => array(
		'recht'        => '*',
		'titel'        => 'E-Mailbenachrichtigungen',
		'beschreibung' => 'legt fest, bei welchen Ereignissen eine E-Mail verschickt wird - für diese Optionengruppe muss bei den Userdaten eine E-Mailadresse eingegeben sein, sonst werden die Einstellungen ignoriert.'
	),
	'mitgliederdetails' => array(
		'recht'        => 'm_anzeigen_name',
		'titel'        => 'Mitgliederdetailanzeige',
		'beschreibung' => 'Optionen für die Mitglieder-Datail-Anzeige'
	),
	'wettkampfabwicklung' => array(
		'recht'        => array('w_abwickeln_eigenemeldung','w_abwickeln_mitglhinzufuegen'),
		'titel'        => 'Wettkampfabwicklung',
		'beschreibung' => 'Optionen für die Abwicklung von Wettkämpfen'
	),
	'dateisystem' => array(
		'recht'        => 's_dateien',
		'titel'        => 'Dateisystem',
		'beschreibung' => 'Optionen für das Dateisystem'
	),
	'stundennachweis' => array(
		'recht'        => 'tr_stundennachweis',
		'titel'        => 'Stundennachweis',
		'beschreibung' => 'Einstellungen für die Übungsleiterstundenabrechung'
	),
	'anwesenheitsliste' => array(
		'recht'        => 'tr_anwesenheitsliste',
		'titel'        => 'Anwesenheitsliste',
		'beschreibung' => 'Einstellungen für die Anwesenheitslisten'
	)
);

$_usereinstellungen = array(
	'globaleeinstellungen' => array(
		'style' => array(
			'titel'    => 'Style',
			'beschreibung' => 'Welche CSS-Datei soll verwendet werden?',
			'art'      => 'datei',
			'verzeichnis' => PFAD_HTTP.'src/css/',
			'standard' => 'screen_original.css',
			'fehler'   => 'Die angegebene CSS-Datei existiert nicht'
		),
		'externecssdatei' => array(
			'titel'    => 'externe CSS-Datei',
			'beschreibung' => 'Soll (zusätzlich) eine externe CSS-Datei verwendet werden?',
			'art'      => 'text',
			'standard' => '',			
			'form'     => '(http.*|)',
			'fehler'   => 'Es muss eine vollständige URL (beginnend mit http://) angegeben werden.'
		),
		'blaetternseiten' => array(
			'titel'    => 'Einträge pro Seite',
			'beschreibung' => 'Wieviele Einträge sollen in Tabellen auf einer Seite angezeigt werden?',
			'art'      => 'text',
			'standard' => '25',			
			'form'     => '[0-9]{1,4}',
			'fehler'   => 'Die Anzahl der Seiten muss eine Zahl (1 bis 4 Stellen) sein'
		),
		'inhaltkomprimiertausliefern' => array(
			'titel'    => 'Seite komprimiert ausliefern',
			'beschreibung' => 'Sollen die Seiten komprimiert ausgeliefert werden? (bei Problemen mit der Seite hilft evtl. ein deaktivieren dieser Option)',
			'art'      => 'bool',
			'standard' => '1',			
			'form'     => '',
			'fehler'   => ''
		),
		'pdfdateiraender' => array(
			'titel'    => 'PDF-Datei Ränder',
			'beschreibung' => 'Die Abstände zwischen Papierrand und bedruckbarem Bereich für den PDF-Export (mit Komma getrennte Werte (in mm) in der Reihenfolge oben, rechts, unten, links)',
			'art'      => 'text',
			'standard' => '10,10,10,10',			
			'form'     => '\s*[0-9]{1,5}(\s*,\s*[0-9]{1,5}){3}\s*',
			'fehler'   => 'Die Ränder für PDF-Dateien sind ungültig'
		),
		'pdfquerformatoben' => array(
			'titel'    => 'PDF-Querformat-oben',
			'beschreibung' => 'Welche Seite ist beim Drucken im Querformat der obere Rand des Ausdrucks?',
			'art'      => 'select',
			'standard' => 'links',
			'werte'    => array(
				'links'  => 'linker Rand',
				'rechts' => 'rechter Rand'
			),
			'fehler'   => 'Der Wert bei "PDF-Querformat-oben" ist ungültig'
		),
		'sicherheitsabfragenabschalten' => array(
			'titel'    => 'Sicherheitsabfr. abschalten',
			'beschreibung' => 'Vor den meisten Löschaktionen wird nochmal nachgefragt, ob wirklich gelöscht werden soll. Mit dieser Option kann die Nachfrage deaktiviert werden. Von einem Aktivieren dieser Option ist allerdings dringend abzuraten!',
			'art'      => 'bool',
			'standard' => '0'
		)  
	),
	'emailbenachrichtigung' => array(
		'fehlendemitgliedskarten' => array(
			'titel'    => 'fehlende Mitgliedskarten',
			'beschreibung' => 'ab der angegebenen Anzahl wird eine E-Mail verschickt, dass x Mitgliederkarten fehlen (0 schaltet die Benachrichtigung aus)',
			'art'      => 'text',
			'recht'    => 'e_fehlendemitgliedskarten',
			'standard' => '0',			
			'form'     => '[0-9]{1,2}',
			'fehler'   => 'Der Wert bei "fehlende Mitgliedskarten" muss eine Zahl zwischen 0 und 99 sein'
		),
		'terminbenachrichtigungszeitraum' => array(
			'titel'    => 'Terminbenachr.-zeitraum',
			'beschreibung' => '',
			'art'      => 'select',
			'werte'    => array(
				'nicht' => 'garnicht',
				'tag'   => 'täglich',
				'woche' => 'wöchentlich',
				'monat' => 'monatlich'
			),
			'recht'    => 's_kalender_anzeigen',
			'standard' => 'woche',
			'fehler'   => 'Der Wert bei "Terminbenachrichtigungszeitraum" ist ungültig'
		),
		'analletermineerinnern' => array(
			'titel'    => 'an alle Termine erinnern',
			'beschreibung' => 'Wenn diese Option aktiviert ist, müssen neue Termine nicht mehr auf "daran erinnern" gesetzt werden sondern es wird (sofern die Erinnerungen eingeschaltet sind) automatisch an alle Termine erinnert',
			'art'      => 'bool',
			'recht'    => 's_kalender_anzeigen',
			'standard' => '1'
		),
		'ablaufendetrainerlizenz' => array(
			'titel'    => 'ablaufende Trainierlizenz',
			'beschreibung' => 'Soll daran erinnert werden, dass die Trainerlizenz abläuft und verlängert werden muss?',
			'art'      => 'bool',
			'recht'    => 'tr_stundennachweis',
			'standard' => '1',			
			'form'     => '',
			'fehler'   => ''
		),
		'terminbenachrichtigungen' => array(
			'titel'    => 'Dummyeintrag zu Terminebenachrichtigungen',
			'beschreibung' => 'Dieser Eintrag ist nur zum Speichern der Einstellungen für Termin-/Geburtstagsbenachrichtigungen da',
			'art'      => 'text',
			'recht'    => '_dummy',
			'standard' => 'termine:|gruppen:|personen:'
		)
	),
	'mitgliederdetails' => array(
		'zeitenentwicklunganzeigen' => array(
			'titel'    => 'Zeitenentwicklung zeigen',
			'beschreibung' => 'Soll die Zeitenentwicklung des Mitgliedes angezeigt werden?',
			'art'      => 'bool',
			'recht'    => 'm_anzeigen_zeiten',
			'standard' => '1'
		),
		'interpoliertezeitenzeigen' => array(
			'titel'    => 'interpolierte Zeiten zeigen',
			'beschreibung' => 'Sollen die interpolierten Zeiten und die Trainingszeiten des Mitgliedes angezeigt werden?',
			'art'      => 'bool',
			'recht'    => 'm_anzeigen_zeiten',
			'standard' => '1'
		),
		'wettkampfteilnahmenanzeigen' => array(
			'titel'    => 'Wettkampfteiln. zeigen',
			'beschreibung' => 'Sollen die Wettkampfteilnahmen des Mitgliedes angezeigt werden?',
			'art'      => 'bool',
			'recht'    => 'm_anzeigen_wettkampfteilnahmen',
			'standard' => '1'
		)
	),
	'wettkampfabwicklung' => array(
		'eigenemeldung_reihenfolgewettkaempfe' => array(
			'titel'    => 'WK-Sortierung bei eig. Meld.',
			'beschreibung' => 'Nach was sollen die Wettkämpfe beim Bearbeiten der eigenen Wettkampfmeldung sortiert werden?',
			'art'      => 'select',
			'werte'    => array(
				'wknr' => 'nach Wettkampfnummer',
				'lage' => 'nach Diszplin und Streckenlänge'
			),
			'recht'    => 'w_abwickeln_eigenemeldung',
			'standard' => 'wknr',
			'fehler'   => 'Der Wert für die Reihenfolge von Wettkämpfen bei eigenen Meldungen ist ungültig.'
		),
		'meldezeitvorbelegung' => array(
			'titel'    => 'Vorbelegung der Meldezeit',
			'beschreibung' => 'wie soll die Auswahlliste für die Meldezeit vorbelegt sein (der zweite Wert wird verwendet, wenn es keine Meldzeit gibt)',
			'art'      => 'select',
			'werte'    => array(
				'a-' => 'aktuelle Zeit, ohne Zeit melden',
				'at' => 'aktuelle Zeit, Textfeld verwenden',
				'b-' => 'beste Zeit, ohne Zeit melden',
				'bt' => 'beste Zeit, Textfeld verwenden'				
			),
			'recht'    => 'w_abwickeln_mitglhinzufuegen',
			'standard' => 'a-',
			'fehler'   => 'Der Wert für die Vorbelegung der Meldezeit ist ungültig.'
		)
	),
	'dateisystem' => array(
		'dateisymbole' => array(
			'titel'    => 'Dateisymbole anzeigen',
			'beschreibung' => 'Sollen die Dateisymbole angezeigt werden?',
			'art'      => 'bool',
			'standard' => '1'
		),
		'klickaufdatei' => array(
			'titel'    => 'Klick auf Datei',
			'beschreibung' => 'Was soll beim Klick auf Dateinamen passieren?',
			'art'      => 'select',
			'werte'    => array(
				'runterladen' => 'Datei herunterladen',
				'details'     => 'Details der Datei zeigen'
			),
			'standard' => 'runterladen',
			'fehler'   => 'Die Aktion beim Klick auf Dateien ist ungültig'
		),
		'csvdateitrenner' => array(
			'titel'    => 'Trenner in csv-Dateien',
			'beschreibung' => 'Mit welchem Zeichen sollen die einzelnen Werte in CSV-Dateien getrennt sein?',
			'art'      => 'select',
			'werte'    => array(
				';'    => 'Semikolon (»;«)',
				','    => 'Komma (»,«)',
				':'    => 'Doppelpunkt (»:«)',
				'tab'  => 'Tabulator (»\t«)',
				'leer' => 'Leerzeichen (» «)'
			),
			'standard' => ';',
			'fehler'   => 'Der Trenner für die Werte in CSV-Datei ist ungültig'
		)
	),
	'stundennachweis' => array(
		'name' => array(
			'titel'    => 'Name',
			'beschreibung' => 'Der Name auf dem Abrechungszettel',
			'art'      => 'text',
			'standard' => '',			
			'form'     => '.{0,80}',
			'fehler'   => 'Der Name muss zwischen 0 und 80 Zeichen lang sein'
		),
		'kontonr' => array(
			'titel'    => 'Kontonummer',
			'beschreibung' => 'Die Kontonummer auf dem Abrechungszettel (Nur für die Abrechnung von Übungsleitern)',
			'art'      => 'text',
			'standard' => '',			
			'form'     => '[0-9]*',
			'fehler'   => 'Die Kontonummer ist keine Zahl'
		),
		'blz' => array(
			'titel'    => 'Bankleitzahl',
			'beschreibung' => 'Die Bankleitzahl auf dem Abrechungszettel (Nur für die Abrechnung von Übungsleitern)',
			'art'      => 'text',
			'standard' => '',			
			'form'     => '[0-9]*',
			'fehler'   => 'Die Bankleitzahl ist keine Zahl'
		),
		'taetigkeit' => array(
			'titel'    => 'Sportart/Tätigkeit',
			'beschreibung' => 'Standardwert für die Tätigkeitsspalte',
			'art'      => 'text',
			'standard' => 'Schwimmen',			
			'form'     => '.{0,80}',
			'fehler'   => 'Die Tätigkeit darf maximal 80 Zeichen enthalten'
		),
		'bemerkung' => array(
			'titel'    => 'Sportstätte/Bemerkung',
			'beschreibung' => 'Standardwert für die Bemerkungsspalte',
			'art'      => 'text',
			'standard' => '',			
			'form'     => '.{0,80}',
			'fehler'   => 'Die Bemerkung darf maximal 80 Zeichen enthalten'
		),
		'eineseitepromonat' => array(
			'titel'    => 'eine Seite pro Monat',
			'beschreibung' => 'Soll für jeden Monat eine eigene Seite ausgegeben werden? (Nur für die Abrechnung von Trainern)',
			'art'      => 'bool',
			'standard' => '1'	
		)
	),
	'anwesenheitsliste' => array(
		'schriftgroesse' => array(
			'titel'    => 'Schriftgröße',
			'beschreibung' => 'Schriftgröße der Liste',
			'art'      => 'select',
			'werte'    => array(
				8  => '8pt',
				9  => '9pt',
				10 => '10pt',
				11 => '11pt',
				12 => '12pt',
				13 => '13pt',
				14 => '14pt'
			),
			'standard' => '12',
			'fehler'   => 'Die Schriftgröße ist ungültig'
		),
		'nummerierung' => array(
			'titel'    => 'Nummerierung',
			'beschreibung' => 'Sollen die Mitglieder auf der Liste durchnumeriert werden?',
			'art'      => 'bool',
			'standard' => '0'
		),
		'sortierung' => array(
			'titel'    => 'Sortierung',
			'beschreibung' => 'Wie sollen die Mitglieder sortiert werden?',
			'art'      => 'select',
			'werte'    => array(
				'nachname'          => 'Nachname, Vorname',
				'vorname'           => 'Vorname, Nachname',
				'jahrgang_vorname'  => 'Jahrgang, Vorname',
				'jahrgang_nachname' => 'Jahrgang, Nachname'
			),
			'standard' => 'nachname',
			'fehler'   => 'Die Art der Sortierung ist ungültig'
		),
		'namensanzeige' => array(
			'titel'    => 'Namensanzeige',
			'beschreibung' => 'Wie soll der Name dargestellt werden?',
			'art'      => 'select',
			'werte'    => array(
				'nachname_vorname' => 'Nachname, Vorname',
				'vorname_nachname' => 'Vorname Nachname',
			),
			'standard' => 'nachname_vorname',
			'fehler'   => 'Die Art der Namensanzeige ist ungültig'
		),
		'anfang' => array(
			'titel'    => 'Anfang',
			'beschreibung' => 'Ab wann soll die Liste gelten?',
			'art'      => 'select',
			'werte'    => array(
				'heute'  => 'Heute',
				'woche'  => 'nächste Woche',
				'monat'  => 'nächsten Monat',
				'ferien' => 'nach den nächsten Ferien',
				'vorgegeben' => 'vorgegebene Zeiträume (siehe Doku)'
			),
			'standard' => 'ferien',
			'fehler'   => 'Der Anfang ist ungültig'
		),
		'zeitraum' => array(
			'titel'    => 'Zeitraum',
			'beschreibung' => 'Wie lange soll die Liste gelten?',
			'art'      => 'select',
			'werte'    => array(
				'monat1' => '1 Monat',
				'monat2' => '2 Monate',
				'monat3' => '3 Monate',
				'monat4' => '4 Monate',
				'monat5' => '5 Monate',
				'monat6' => '6 Monate'
			),
			'standard' => 'monat3',
			'fehler'   => 'Der Zeitraum ist ungültig'
		)
	)
);
# EOF
?>