<?php
# Funktion entfernen
function holeBestenlistenDaten($lage,$laenge,$mw,$anzahl,$conf=array()){
	global $_db,$_tmpl,$_lagen;
	$laengen = array(25=>'25m',50=>'50m',100=>'100m',200=>'200m',400=>'400m',800=>'800m',1500=>'1500m');
	if(isset($conf['alter']) and isset($conf['jahrgang'])){
		unset($conf['alter']);
	}
	# WHERE-Teil zusammenbauen
	$where = "disziplin = ".$lage." AND m.mw = '".$mw."' AND bestenliste = 1 AND zeit IS NOT NULL";
	$where .= " AND streckenlaenge = ".$laenge." AND z.mitgliedid = m.id AND z.wettkampfid = w.id";
	if(isset($conf['alter'])){
		if(ctype_digit($conf['alter'])){
			$where .= ' AND YEAR(z.datum)-YEAR(m.gebdatum) = '.$conf['alter'];
		}
		else{
			global $_altersklassen;
			if($conf['alter'] == 'ak95'){
				$alter = implode(',',range(95,130));
			}
			else{
				$alter = $_altersklassen[$conf['alter']];
			}
			$where .= ' AND YEAR(z.datum)-YEAR(m.gebdatum) IN ('.$alter.')';
		}
	}
	if(isset($conf['bahnlaenge'])){
		$where .= " AND bahnlaenge = '".$conf['bahnlaenge']."'";
	}
	if(isset($conf['maxalter'])){
		$where .= ' AND YEAR(z.datum)-YEAR(m.gebdatum) <= '.$conf['maxalter'];
	}
	if(isset($conf['vordatum'])){
		$where .= " AND z.datum < '".$conf['vordatum']."'";
	}
	if(isset($conf['nichtwk'])){
		$where .= " AND z.wettkampfid != '".$conf['nichtwk']."'";
	}
	# alle Zeiten holen (ggf. eingeschraenkt durch das Alter der Schwimmer und die Bahnlaenge)
	$query = "SELECT '' as nr, m.id, z.id as zid, m.nachname, m.vorname, YEAR(m.gebdatum) as jg, z.zeit, YEAR(z.datum) as jahr,
				  DATE_FORMAT(z.datum,'%d.%m.%Y') as datum, YEAR(z.datum)-YEAR(m.gebdatum) as alt, w.titel, w.bahnlaenge,
				  CONCAT(LPAD(z.zeit,7,'0'),'-',z.datum) as sort, z.datum as datumsort, w.ort, w.id as wid
				FROM ".DB_PREFIX."zeiten as z, ".DB_PREFIX."mitglieder as m, ".DB_PREFIX."wettkaempfe as w
				WHERE ".$where."
				ORDER BY zeit DESC, z.datum ASC, alt ASC";
	$_db->holeDaten($query);
	if($_db->ergebnis['anzahl']<1){
		return array('daten'=>array(),'letztesdatum'=>'');
	}
	$zeiten = $_db->baueArray('*','id');

	$rueckgabe = array(
		'daten' => array(),
		'letztesdatum' => array()
	);
	# letztes Datum raussuchen (vor den Einschränkungen)
	$datumsort = $_db->baueArray('datumsort','id');
	rsort($datumsort);
	$rueckgabe['letztesdatum'] = $datumsort[0];

	# Zeiten sortieren
	$sort = $_db->baueArray('sort','id');
	asort($sort);
	$daten = array();
	foreach($sort as $id => $z){
		$daten[] = $zeiten[$id];
	}
	# benötige Mitglieder holen
	$gesuchte = array(); # gesuchte Mitglieder (was hier nicht drin ist, weg)
	if(isset($conf['ausgetreteneignorieren'])){ # ausgetretene
		$query = "SELECT id FROM ".DB_PREFIX."mitglieder WHERE ausgetreten IS NULL";
		$_db->holeDaten($query);
		if($_db->ergebnis['anzahl']>0){
			$gesuchte[] = $_db->baueArray('id');
		}
	}
	if(isset($conf['nuraktive'])){ # inaktive
		$query = "SELECT DISTINCT mitgliedid as id FROM ".DB_PREFIX."mitglieder_trainingsgruppen";
		$_db->holeDaten($query);
		if($_db->ergebnis['anzahl']>0){
			$gesuchte[] = $_db->baueArray('id');
		}
	}
	if(isset($conf['jahrgang'])){ # Jahrgang
		$query = "SELECT id FROM ".DB_PREFIX."mitglieder WHERE YEAR(gebdatum) = '".$conf['jahrgang']."'";
		$_db->holeDaten($query);
		if($_db->ergebnis['anzahl']>0){
			$gesuchte[] = $_db->baueArray('id');
		}
	}
	# nicht benoetigte Zeiten ausfiltern
	$anzges = count($gesuchte);
	if($anzges > 0){
		foreach($daten as $key => $row){
			for($i=0;$i<$anzges;$i++){
				if(!in_array($row['id'],$gesuchte[$i])){
					unset($daten[$key]);
					continue 2;
				}
			}
		}
	}
	# doppelte Mitglieder entfernen
	$vorhanden = array();
	foreach($daten as $key => $row){
		if(!in_array($row['id'],$vorhanden)){
			$vorhanden[] = $row['id'];
			continue;
		}
		unset($daten[$key]);
	}
	# Daten aufbereiten (Zeiten formatieren, $anzahl beruecksichtigen)
	$i = 1;
	$itmp = $i;
	$zeittmp = '';
	foreach($daten as $row){
		$row['zeit'] = text_format($row['zeit'],'schwimmzeit');
		if($zeittmp == $row['zeit']){
			$row['nr'] = $itmp;
		}
		else{
			$itmp = $i;
			$row['nr'] = $itmp;
			$zeittmp = $row['zeit'];
		}
		unset($row['jahr']);
		$rueckgabe['daten'][] = $row;
		$i++;
		if($i>$anzahl){
			break;
		}
	}
	return $rueckgabe;
}
# EOF
?>