<?php

function setzeMitgliedAufAusgetreten($id,$jahr,&$db){
/*
setzt Mitglied(er) auf ausgetreten und führt die nötigen Aktionen aus.
Parameter:
 - id: die ID des Mitgliedes oder ein Array mit den IDs der Mitglieder
 - jahr: das Jahr in dem das Mitglied ausgetreten ist
 - db: die Datenbankverbindung
*/
	if(!is_array($id)){
		$id = array($id);
	}
	if(!preg_match('~^[0-9]{4}$~D',$jahr)){
		return false;
	}

	# pruefen ob IDs existieren
	$ids = array();
	foreach($id as $i){
		$ids[] = text_format($i,'db');
	}
	$query = "SELECT id FROM ".DB_PREFIX."mitglieder WHERE id IN ('".implode("','",$ids)."')";
	$db->holeDaten($query);
	if($db->holeAnzahl() < 1){
		return false;
	}
	$id = $db->baueArray('id','#');
	$id_str = implode(",",$id);

	# evtl. vorhandene Langnamen in das Sonstiges-Feld schreiben
	$query = "SELECT artid, wert FROM ".DB_PREFIX."eigenschaften WHERE eigenschaft = 'langname' AND artid IN (".$id_str.")";
	$db->holeDaten($query);
	if($db->holeAnzahl() > 0){
		$werte = $db->baueArray('wert','artid');
		foreach($werte as $mid => $name){
			$str = 'Langname: '.str_replace('|', ' ', $name);
			$query = "UPDATE ".DB_PREFIX."mitglieder SET sonstiges = LTRIM(CONCAT(sonstiges,'\n','".$str."')) WHERE id = ".$mid."";
			$db->fuehreQueryAus($query);
		}
	}

	# Mitglied auf ausgetreten setzen
	$query = "UPDATE ".DB_PREFIX."mitglieder SET ausgetreten = ".$jahr." WHERE id IN (".$id_str.")";
	$db->fuehreQueryAus($query);

	# Eigenschaften löschen
	$zuloeschende = array('aufnahmeformulargeben','keinekartemachen','keinewettkampfteilnahme','alteadresse','langname');
	$query = "DELETE FROM ".DB_PREFIX."eigenschaften
				WHERE artid IN (".$id_str.") AND art = 'm' AND eigenschaft IN ('".implode("','",$zuloeschende)."')";
	$db->fuehreQueryAus($query);

	# Kampfrichter löschen
	$query = "DELETE FROM ".DB_PREFIX."kampfrichter WHERE id IN (".$id_str.")";
	$db->fuehreQueryAus($query);

	# Logindaten löschen
	$query = "DELETE FROM ".DB_PREFIX."logins WHERE id IN (".$id_str.")";
	$db->fuehreQueryAus($query);

	# aktuelle Zeiten löschen
	$query = "DELETE FROM ".DB_PREFIX."aktuellezeiten WHERE mid IN (".$id_str.")";
	$db->fuehreQueryAus($query);

	# Rechte- und Trainingsgruppenzuordungen löschen
	$query = "DELETE FROM ".DB_PREFIX."rechtegruppen_mitglieder WHERE mitgliedid IN (".$id_str.")";
	$db->fuehreQueryAus($query);
	$query = "DELETE FROM ".DB_PREFIX."mitglieder_trainingsgruppen WHERE mitgliedid IN (".$id_str.")";
	$db->fuehreQueryAus($query);

	return count($id);
}
# EOF
?>