<?php
require_once('./__inc/_start.inc.php');
$_seite = 0;

if(!isset($_GET['art'])){
	exit;
}

switch($_GET['art']){
case 'bilder':
	if(!isset($_SESSION['eingelogt']) or !pruefeRechte('s_bilder_anzeigen')){
		$_inh .= T_KEINZUGRIFF;
		break;
	}
	require_once(PFAD_INCLUDE.'class/bilder.inc.php');
	$_bilder = new bilder;
	if(!ctype_digit($_GET['album'])){
		exit;
	}
	$verzeichnis = $_bilder->holeVerzeichnis($_GET['album'], false);
	header("Content-type: image/jpeg");
	header('Content-Length: '.filesize($verzeichnis.$_GET['id'].'.jpg'));
	header('Content-Disposition: inline; filename="bilder_'.$_GET['album'].'_'.$_GET['id'].'.jpg"');
	readfile($verzeichnis.$_GET['id'].'.jpg');
	exit;

case 'zeitenentwicklung':
	if(!isset($_SESSION['eingelogt']) or (!pruefeRechte('m_anzeigen_zeiten') and $_SESSION['user']['id']!=$_GET['id'])){
		$_inh .= T_KEINZUGRIFF;
		break;
	}
	$hoehe = 500;
	$breite = 800;
	require_once(PFAD_INCLUDE.'class/diagramme.inc.php');
	$diagr = new diagramme($breite, $hoehe);
	if($diagr === false){
		exit;
	}
	$mid = $_GET['id'];
	# Mitgliedid, Anzahl der Zeiten und Datum der neuesten Zeit holen
	$query = "SELECT m.id, COUNT(z.id) as anz, UNIX_TIMESTAMP(MAX(datum)) as neuestezeit
				FROM ".DB_PREFIX."mitglieder as m LEFT JOIN ".DB_PREFIX."zeiten as z ON m.id=z.mitgliedid
				WHERE m.id = '".text_format($_GET['id'],'db')."' AND wettkampfid >= 7 AND zeit IS NOT NULL AND bestenliste = 1 AND
				  streckenlaenge BETWEEN 50 AND 200
				GROUP BY m.id";
	$_db->holeDaten($query);
	if($_db->holeAnzahl() != 1 or $_db->holeWert('anz') < 2){
		$_tmpl->assign('fehler','Das Mitglied existiert nicht und/oder es sind zu wenig bzw. keine Zeiten vorhanden');
	}
	else{
		$_GET['id'] = $_db->holeWert('id');
		$generieren = false;
		# pruefen ob Bild schon vorhanden ist
		if(file_exists(PFAD_INCLUDE.'bilder_speicher/zeitenentwicklung_'.$_GET['id'].'.png')){
			# pruefen ob Bild noch aktuell ist
			$neuestezeit = $_db->holeWert('neuestezeit');
			$erstelldatum = filemtime(PFAD_INCLUDE.'bilder_speicher/zeitenentwicklung_'.$_GET['id'].'.png');
			if($erstelldatum < $neuestezeit){
				$generieren = true;
			}
		}
		else{
			$generieren = true;
		}
		if($generieren){
			# Einstellungen festlegen, Mitglied
			$diagr->setzeFarbe('hintergrund',255,255,255);
			$diagr->setzeFarbe('schrift',0,0,0);
			$diagr->setzeFarbe('linien',0,0,0);
			$diagr->setzeFarbe('freistil',0,0,255);
			$diagr->setzeFarbe('brust',255,0,0);
			$diagr->setzeFarbe('ruecken',184,159,57);
			$diagr->setzeFarbe('schmetterling',0,255,0);
			$diagr->setzeFarbe('lagen',0,0,0);
			$diagr->setzeSchrift(PFAD_INCLUDE.'export/img_fonts/DejaVuSans.ttf');
			# Zeiten holen
			$query = "SELECT datum, zeit, CONCAT(disziplin,'-',streckenlaenge) as sort
						FROM ".DB_PREFIX."zeiten
						WHERE mitgliedid = ".$mid." AND wettkampfid >= 7 AND zeit IS NOT NULL AND bestenliste = 1 AND
						  streckenlaenge BETWEEN 50 AND 200
						ORDER BY disziplin, streckenlaenge, datum";
			$_db->holeDaten($query);
			$zeiten = $_db->baueArray('*','#');
			$min_zeit = 360000;
			$max_zeit = 0;
			$min_datum = '9999-12-31';
			$max_datum = '1000-01-01';
			foreach($zeiten as $row){
				if($row['zeit'] < $min_zeit){
					$min_zeit = $row['zeit'];
				}
				if($row['zeit'] > $max_zeit){
					$max_zeit = $row['zeit'];
				}
				if($row['datum'] < $min_datum){
					$min_datum = $row['datum'];
				}
				if($row['datum'] > $max_datum){
					$max_datum = $row['datum'];
				}
			}

			$mindatum_timestamp = strtotime($min_datum);
			foreach($zeiten as $key => $row){
				$zeiten[$key]['tage'] = round((strtotime($row['datum'])-$mindatum_timestamp)/86400);
			}
			$diagr->setzeAchse('y', 'schwimmzeiten', $min_zeit, $max_zeit);
			$diagr->setzeAchse('x', 'datum', $min_datum, $max_datum);
			$diagr->zeichneAchsen();
			$diagr->zeichneWerte($zeiten, 'tage', 'zeit', 'sort');
			$diagr->setzeLegende('freistil','Freistil');
			$diagr->setzeLegende('brust','Brust');
			$diagr->setzeLegende('ruecken','Rücken');
			$diagr->setzeLegende('schmetterling','Schmetterling');
			$diagr->setzeLegende('lagen','Lagen');
			$diagr->zeichneLegende();
			$bild = $diagr->gebeDiagrammAus(true);
			if(!is_writable(PFAD_INCLUDE.'bilder_speicher/')){
				trigger_error('[tkswim]Bild vom Mitglied mit der ID '.$_GET['id'].' konnte nicht geschrieben werden.',E_USER_WARNING);
				header("Content-type: image/png");
				echo $bild;
				exit;
			}
			$fh = fopen(PFAD_INCLUDE.'bilder_speicher/zeitenentwicklung_'.$_GET['id'].'.png','w');
			fwrite($fh, $bild, strlen($bild));
			fclose($fh);
		}
		header("Content-type: image/png");
		header('Content-Length: '.filesize(PFAD_INCLUDE.'bilder_speicher/zeitenentwicklung_'.$_GET['id'].'.png'));
		header('Content-Disposition: inline; filename="zeitenentwicklung_'.$_GET['id'].'.png"');
		readfile(PFAD_INCLUDE.'bilder_speicher/zeitenentwicklung_'.$_GET['id'].'.png');
		exit;
	}
default:
	break;
} # Ende switch
exit;
# EOF
?>