<?php
require_once('../__inc/_start.inc.php');
$_seite = 46;
$erlaubt = pruefeRechte('w_lizenzen_anzeigen');
$titel = 'Lizenzen';
$_tmpl->assign('ueberschrift',' Lizenzen');
if(!$erlaubt){
	$_inh = T_KEINZUGRIFF;
}
else{
$_GET['aktion'] = isset($_GET['aktion'])?$_GET['aktion']:'';
switch($_GET['aktion']){
case 'allelizenzierungen':
	$query = "SELECT mitgliedid, jahr FROM ".DB_PREFIX."lizenzierungen";
	$_db->holeDaten($query);
	if($_db->holeAnzahl() < 1){
		weiterleiten('/wettkaempfe/lizenzen'.TKSWIM_DATEIENDUNG,'Es sind keine Lizenzen vorhanden');
	}
	$allelizenzen = $_db->baueArray('*','#');
	$jahre = $_db->baueArray('jahr','jahr');
	krsort($jahre);
	$anzahl = array();
	foreach($jahre as $jahr => $wert){
		$jahre[$jahr] = array();
		$anzahl[$jahr] = 0;
	}
	foreach($allelizenzen as $row){
		$jahre[$row['jahr']][] = $row['mitgliedid'];
		$anzahl[$row['jahr']]++;
	}
	$mitgliederids = array_unique($_db->baueArray('mitgliedid','#'));
	$query = "SELECT id, nachname, vorname, dsvid, YEAR(gebdatum) as jg, ausgetreten, YEAR(eingetreten) as eingetreten
				FROM ".DB_PREFIX."mitglieder
				WHERE id IN (".implode(',',$mitgliederids).") ORDER BY nachname, vorname";
	$_db->holeDaten($query);
	$daten = $_db->baueArray('*','id');
	$mitglieder = array();
	foreach($daten as $row){
		$mitglieder[$row['id']] = $row;
		$mitglieder[$row['id']]['lizenzen'] = array();
		foreach($jahre as $jahr => $mids){
			$wert = '-';
			if(in_array($row['id'],$mids)){
				$wert = 'x';
			}
			elseif(!is_null($row['ausgetreten']) and $row['ausgetreten'] < $jahr){
				$wert = 'k';
			}
			elseif($row['eingetreten'] != '0' and $row['eingetreten'] >= $jahr){
				$wert = 'k';
			}
			elseif($jahr-$row['jg'] < 10){
				$wert = 'nn';
			}
			$mitglieder[$row['id']]['lizenzen'][$jahr] = $wert;
		}
	}
	$_tmpl->assign('anzahl',$anzahl);
	$_tmpl->assign('jahre',$jahre);
	$_tmpl->assign('anzjahre',count($jahre));
	$_tmpl->assign('mitglieder',$mitglieder);
	$_inh .= $_tmpl->fetch('wettkaempfe/46.lizenzen-aelterelizenzierungen.inc.html');
	break;

case 'beantragtedsvids':
	if(!pruefeRechte('w_lizenzen_bearbeiten')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	$query = "SELECT m.id, m.nachname, m.vorname, YEAR(gebdatum) as jg, e.wert
				FROM ".DB_PREFIX."mitglieder as m LEFT JOIN ".DB_PREFIX."eigenschaften as e ON e.artid=m.id AND e.art='m' AND e.eigenschaft='dsvidbeantragt'
				WHERE e.wert IS NOT NULL ORDER BY m.nachname, m.vorname";
	$_db->holeDaten($query);
	$mitglieder = $_db->baueArray('*','id');

	if(isset($_GET['flagloeschen']) and in_array($_GET['flagloeschen'],array_keys($mitglieder))){
		if(!isset($_GET['sicher'])){
			$_tmpl->assign('frage','Soll das Flag "DSV-ID beantragt" wirklich gelöscht werden?');
			$_tmpl->assign('neinquery','aktion=beantragtedsvids');
			$_tmpl->assign('url', '/wettkaempfe/lizenzen'.TKSWIM_DATEIENDUNG);
			$_inh .= $_tmpl->fetch('tools/9902.loeschfrage.inc.html');
		}
		else{
			$query = "DELETE FROM ".DB_PREFIX."eigenschaften
						WHERE art = 'm' AND eigenschaft = 'dsvidbeantragt' AND artid = ".$_GET['flagloeschen']."";
			$_db->fuehreQueryAus($query);
			weiterleiten('/wettkaempfe/lizenzen'.TKSWIM_DATEIENDUNG.'?aktion=beantragtedsvids','Das "DSV-ID beantragen"-Flag wurde gelöscht');
		}
	}

	if(isset($_POST['speichern']) and isset($_POST['dsvids']) and is_array($_POST['dsvids'])){
		require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
		$f = '';
		$eingegeben = false;
		# vorhandene DSV-IDs holen
		$query = "SELECT dsvid FROM ".DB_PREFIX."mitglieder WHERE dsvid IS NOT NULL";
		$_db->holeDaten($query);
		$dsvids = $_db->baueArray('dsvid','#');
		foreach($_POST['dsvids'] as $mid => $dsvid){
			if(!in_array($mid,array_keys($mitglieder)) or empty($dsvid)){
				unset($_POST['dsvids'][$mid]);
				continue;
			}
			$eingegeben = true;
			$f .= pruefen($dsvid,'zahl','Die DSV-ID ist ungültig.');
			$f .= pruefen($dsvid,'maxlaenge','Die DSV-ID ist zu lang (max 7 Zeichen)',7);
			if(in_array($dsvid,$dsvids)){
				$f .= 'Es gibt bereits ein Mitglied mit dieser DSV-ID<br />';
			}
			if(isset($_POST['lizenzieren']) and in_array($mid,$_POST['lizenzieren']) and (date('Y')-$mitglieder[$mid]['jg'])<10){
				$f .= 'Mitglieder können erst ab 10 Jahren lizenziert werden.<br />';
			}
		}
		if(!$eingegeben){
			$f .= 'Es wurden keine IDs eingegeben.<br />';
		}
		if(!empty($f)){
			$_tmpl->assign('fehler',$f);
		}
		else{
			$lqueryteile = array();
			$jahr = date('Y');
			foreach($_POST['dsvids'] as $mid => $dsvid){
				if(isset($_POST['lizenzieren']) and in_array($mid,$_POST['lizenzieren'])){
					$lqueryteile[] = '('.$mid.','.$jahr.')';
				}
				$query = "UPDATE ".DB_PREFIX."mitglieder SET dsvid = ".$dsvid." WHERE id = ".$mid."";
				$_db->fuehreQueryAus($query);
				unset($mitglieder[$mid]);
			}
			if(count($lqueryteile) > 0){
				$lquery = "INSERT INTO ".DB_PREFIX."lizenzierungen (mitgliedid,jahr) VALUES ".implode(', ',$lqueryteile)."";
				$_db->fuehreQueryAus($lquery);
			}
			$query = "DELETE FROM ".DB_PREFIX."eigenschaften
						WHERE art = 'm' AND eigenschaft = 'dsvidbeantragt' AND artid IN (".implode(',',array_keys($_POST['dsvids'])).")";
			$_db->fuehreQueryAus($query);
			$_SESSION['hinweis'] = 'Die DSV-ID'.(count($_POST['dsvids'])==1?' wurde':'s wurden').' gespeichert.';
		}
		if(isset($_POST['lizenzieren'])){
			$_tmpl->assign('lizenzieren',$_POST['lizenzieren']);
		}
		$_tmpl->assign('dsvids',$_POST['dsvids']);
	}
	else{
		$lizenzieren = array();
		$jahr = date('Y');
		foreach($mitglieder as $mid => $row){
			if($jahr-$row['jg'] >= 10){
				$lizenzieren[] = $mid;
			}
		}
		$_tmpl->assign('lizenzieren',$lizenzieren);
	}

	$_tmpl->assign('mitglieder',$mitglieder);
	$_tmpl->assign('jahr',date('Y'));
	$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.message,jquery.ui,jquery.tkswim');
	$_tmpl->tk_javascriptzuweisen('onready', "\$('.loeschen').tkswim_loeschfrage({art:'lizenzbeantragtflag',frage:'Soll das Flag »DSV-ID beantragt« wirklich gelöscht werden?',tabellenid:'lizenzbeantragtflags'});");
	$_inh .= $_tmpl->fetch('wettkaempfe/46.lizenzen-beantragtedsvids.inc.html');
	break;

case 'registrierungsformulare':
	if(!pruefeRechte('w_lizenzen_bearbeiten')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	if(!isset($_POST['ids'])){ # Mitglieder auswaehlen
		# Mitglieder in Trainingsgruppen
		$query = "SELECT DISTINCT m.id, CONCAT(m.nachname,', ',m.vorname,' (',YEAR(m.gebdatum),')') as name
					FROM ".DB_PREFIX."mitglieder as m LEFT JOIN ".DB_PREFIX."eigenschaften as e
					ON e.art='m' AND e.artid=m.id AND e.eigenschaft='dsvidbeantragt', ".DB_PREFIX."mitglieder_trainingsgruppen as mt
					WHERE m.id=mt.mitgliedid AND dsvid IS NULL AND e.wert IS NULL ORDER BY m.nachname, m.vorname ";
		$_db->holeDaten($query);
		$_tmpl->assign('trainingsgruppen',$_db->baueArray('name','id'));
		# alle Mitglieder
		$query = "SELECT id, CONCAT(nachname,', ',vorname,' (',YEAR(gebdatum),')') as name
					FROM ".DB_PREFIX."mitglieder as m LEFT JOIN ".DB_PREFIX."eigenschaften as e
					ON e.art='m' AND e.artid=m.id AND e.eigenschaft='dsvidbeantragt'
					WHERE ausgetreten IS NULL AND dsvid IS NULL AND e.wert IS NULL ORDER BY nachname, vorname";
		$_db->holeDaten($query);
		$_tmpl->assign('allemitglieder',$_db->baueArray('name','id'));
		$_inh .= $_tmpl->fetch('wettkaempfe/46.lizenzen-registrierungsformulare-mitglieder.inc.html');
	}
	else{ # weitere Angaben
		$ids = array();
		foreach($_POST['ids'] as $id){
			$ids[] = text_format($id,'db');
		}
		$query = "SELECT id
					FROM ".DB_PREFIX."mitglieder as m LEFT JOIN ".DB_PREFIX."eigenschaften as e
					ON e.artid=m.id AND e.art='m' AND e.eigenschaft='dsvidbeantragt'
					WHERE id IN (".implode(',',$ids).") AND dsvid IS NULL AND ausgetreten IS NULL AND e.wert IS NULL";
		$_db->holeDaten($query);
		if($_db->ergebnis['anzahl'] < 1){
			$_tmpl->assign('fehler','Es wurde kein Mitglied ausgewählt');
			break;
		}
		$ids = $_db->baueArray('id','#');
		$query = "SELECT v.id, CONCAT(v.bezeichnung, ' (', CONCAT(vorname,' ',nachname),')') as bezeichnung, mitgliedid
					FROM ".DB_PREFIX."vorstand as v LEFT JOIN ".DB_PREFIX."mitglieder as m ON v.mitgliedid = m.id 
					WHERE nachname IS NOT NULL ORDER BY v.sort";
		$_db->holeDaten($query);
		$vorstand = $_db->baueArray('mitgliedid','id');
		$_tmpl->assign('vorstand',$_db->baueArray('bezeichnung','id'));
		if(isset($_POST['speichern'])){
			# pruefen
			require_once(PFAD_INCLUDE.'func/pruefen.inc.php');
			$f = '';
			$d = &$_POST['daten'];
			# Vorstand
			$f .= pruefen($d['verein']['ansprechpartner'],'wertemenge','Der Ansprechpartner ist ungültig',array_keys($vorstand));
			if(empty($f) and is_null($vorstand[$d['verein']['ansprechpartner']])){
				$f .= 'Dem Vorstandsamt ist kein Mitglied zugewiesen<br />';
			}
			# Zahlungsweise
			if(!isset($d['zahlungsweise'])){
				$f .= 'Der Wert für die Zahlungsweise fehlt.<br />';
			}
			else{
				if(!in_array($d['zahlungsweise'],array('ueberweisung','einzugsermaechtigung'))){
					$f .= 'Der Wert für die Zahlungsweise ist ungültig.<br />';
				}
			}
			$jahr = date('Y');
			$monat = date('n');
			$erlaubtejahre = array($jahr);
			if($monat == 1){
				$erlaubtejahre[] = $jahr-1;
			}
			if($monat > 10){
				$erlaubtejahre[] = $jahr+1;
			}
			if(count($erlaubtejahre) == 1){
				$erlaubtejahre_text = 'das Jahr '.$erlaubtejahre[0];
			}
			else{
				$erlaubtejahre_text = 'die Jahre '.$erlaubtejahre[0].' und '.$erlaubtejahre[1];
			}
			foreach($d['mitglieder'] as $id => $row){
				if(!in_array($id,$ids)){
					unset($d['mitglieder'][$id]);
					continue;
				}
				$fname = text_format($row['name'],'htmlmaskieren');
				if(!empty($row['jahr'])){
					$f .= pruefen($row['jahr'],'wertemenge','Das Lizenzierungsjahr ist ungültig (nur '.$erlaubtejahre_text.') ('.$fname.')',$erlaubtejahre);
				}
				if(empty($row['jahr']) and isset($row['lizenzieren'])){
					$f .= 'Um ein Mitglied zu lizenzieren muss das Lizenzierungsjahr angegeben werden ('.$fname.')<br />';
				}
			}
			if(!empty($f)){ # Fehler
				$_tmpl->assign('fehler',$f);
				$_tmpl->assign('daten',$_POST['daten']);
			}
			else{ # Datei generieren
				require_once(PFAD_INCLUDE.'class/ooodateien.inc.php');
				$ooo = new ooodateien($_tmpl,'erstregistrierung');
				# Daten einsammeln
				# Meta-Daten
				$_meta = array(
					'generator' => 'tkswim '.TKSWIM_VERSION,
					'titel'     => 'Antraege auf Erstregistrierung (DSV-Form 006)',
					'creator'   => $_SESSION['user']['realname'],
					'date'      => date('Y-m-d\TH:i:s')
				);
				$ooo->setzeWerte('_meta',$_meta);
				# Ansprechpartner
				$query = "SELECT CONCAT(nachname,', ',vorname) as name, email, CONCAT(plz,' ',ort) as plzort, CONCAT(strasse,' ',hausnr) as strasse
							FROM ".DB_PREFIX."mitglieder WHERE id = ".$vorstand[$d['verein']['ansprechpartner']]."";
				$_db->holeDaten($query);
				$row = $_db->holeZeile();
				$query = "SELECT CONCAT(vorwahl,'/',nummer) as nr, telefonart FROM ".DB_PREFIX."telefon
							WHERE mitgliedid = ".$vorstand[$d['verein']['ansprechpartner']]." AND telefonart IN (1,4)";
				$_db->holeDaten($query);
				$row['tel'] = '-';
				$row['fax'] = '-';
				if($_db->holeAnzahl() != 0){
					$tel = $_db->baueArray('nr','telefonart');
					if(isset($tel[1])){
						$row['tel'] = $tel[1];
					}
					if(isset($tel[4])){
						$row['fax'] = $tel[4];
					}
				}
				$verein = array(
					'name'         => TKSWIM_VEREIN,
					'id'           => TKSWIM_VEREINSID,
					'stammverein'  => '',
					'sb_name'      => $row['name'],
					'sb_plzort'    => $row['plzort'],
					'sb_strasse'   => $row['strasse'],
					'sb_tel'       => $row['tel'],
					'sb_fax'       => $row['fax'],
					'sb_email'     => $row['email']
				);
				$ooo->setzeWerte('verein',$verein);
				# Mitglieder
				$query = "SELECT id, nachname, vorname, DATE_FORMAT(gebdatum,'%d.%m.%Y') as geburtsdatum, mw, CONCAT(plz,' ',ort) as plzort,
							CONCAT(strasse,' ',hausnr) as strasse
							FROM ".DB_PREFIX."mitglieder WHERE id IN (".implode(', ',$ids).") ORDER BY nachname, vorname";
				$_db->holeDaten($query);
				$mitglieder = $_db->baueArray('*','id');
				$queryteil = array();
				foreach($_POST['daten']['mitglieder'] as $id => $row){
					if(isset($row['lizenzieren'])){
						$mitglieder[$id]['jahr'] = $row['jahr'];
					}
					$queryteil[] = "('m',".$id.",'dsvidbeantragt','".date('d.m.Y')."')";
				}
				# "DSV-ID beantragt"-Flags setzen
				$query = "INSERT INTO ".DB_PREFIX."eigenschaften (art,artid,eigenschaft,wert) VALUES ".implode(', ',$queryteil)."";
				$_db->fuehreQueryAus($query);
				$ooo->setzeWerte('mitglieder',$mitglieder);
				# Zahlungsweise
				$zahlungsweise = array(
					'zahlungsweise' => $_POST['daten']['zahlungsweise'],
					'einzugliegtvor' => isset($_POST['daten']['einzugsermaechtigungliegtvor'])
				);
				if($zahlungsweise['zahlungsweise'] == 'ueberweisung'){
					$zahlungsweise['einzugliegtvor'] = NULL;
				}
				$ooo->setzeWerte('zahlungsweise',$zahlungsweise);
				$ooo->setzeEinstellung('ooo:configuration-settings','AddParaTableSpacingAtStart','boolean',true);
				# Datei generieren
				$ooo->generiereDateien();
				$ooo->setzeDateiname(date('Y-m').'_lizenzbeantragungen.odt');
				$ooo->gebeOooDateiAus();
			}
		}
		else{
			$query = "SELECT id, CONCAT(nachname,', ',vorname) as name, YEAR(gebdatum) as jg
						FROM ".DB_PREFIX."mitglieder WHERE id IN (".implode(',',$ids).")
						ORDER BY nachname, vorname";
			$_db->holeDaten($query);
			$mitglieder = $_db->baueArray('*','id');
			$jahr = date('Y');
			if(isset($_GET['lizenzjahr']) and in_array($_GET['lizenzjahr'],array($jahr,$jahr-1,$jahr+1))){
				$jahr = $_GET['lizenzjahr'];
			}
			foreach($mitglieder as $id => $row){
				if($jahr-$row['jg'] >= 10){
					$mitglieder[$id]['jahr'] = $jahr;
					$mitglieder[$id]['lizenzieren'] = 1;
				}
				else{
					$mitglieder[$id]['jahr'] = '';
				}
			}
			$daten = array(
				'verein' => array(
					'ansprechpartner' => 4
				),
				'mitglieder' => $mitglieder
			);
			$_tmpl->assign('daten',$daten);
		}
		$_inh .= $_tmpl->fetch('wettkaempfe/46.lizenzen-registrierungsformulare-formular.inc.html');
	}
	break;

case 'lizenzierungen':
	if(!pruefeRechte('w_lizenzen_bearbeiten')){
		$_inh = T_KEINZUGRIFF;
		break;
	}
	$jahr = date('Y');
	$monat = date('m');
	$lizenzjahre = array(
		1 => $jahr,
		2 => ($monat<9?$jahr-1:$jahr+1)
	);
	if(isset($_POST['speichern']) and in_array($_POST['jahr'],$lizenzjahre) and isset($_POST['zulizenzierende']) and count($_POST['zulizenzierende'])>0){
		$ids = $_POST['zulizenzierende'];
		foreach($ids as $key => $id){
			$ids[$key] = text_format($id,'db');
		}
		$query = "SELECT id FROM ".DB_PREFIX."mitglieder
				WHERE id IN (".implode(',',$ids).") AND dsvid IS NOT NULL AND (".$_POST['jahr']."-YEAR(gebdatum))>=10";
		$_db->holeDaten($query);
		if($_db->holeAnzahl() > 0){
			$ids = $_db->baueArray('id','#');
			$queryteile = array();
			foreach($ids as $id){
				$queryteile[] = '('.$id.','.$_POST['jahr'].')';
			}
			$query =  "INSERT INTO ".DB_PREFIX."lizenzierungen (mitgliedid,jahr) VALUES ".implode(', ',$queryteile)."";
			$_db->fuehreQueryAus($query);
			$anz = count($queryteile);

			if(isset($_POST['beimdsvbeantragen'])){
				# Aufgrund der Unfähigkeit des DSV ist diese Funktion im Moment leider noch nicht möglich
				unset($_POST['beimdsvbeantragen']);
			}
			if(isset($_POST['beimdsvbeantragen'])){
				define('BR', PHP_EOL);
				# Einleitung
				$text =  'Sehr geehrte DSV Geschäftsstelle,'.BR.BR;
				$text .= 'nachfolgend erhalten Sie eine Lizenzbeantragung für das Jahr '.$_POST['jahr'].':'.BR.BR;
				# Absender
				$text .= 'Gesendet von:'.BR;
				$text .= '====================================='.BR;
				$text .= '[Name]'.BR;
				$text .= 'Funktion: ...'.BR;
				$text .= 'Verein (ID): '.TKSWIM_VEREIN.' ('.TKSWIM_VEREINSID.')'.BR;
				$text .= 'E-Mail: ...'.BR;
				$text .= 'Telefon: ...'.BR;
				$text .= 'Straße: ...'.BR;
				$text .= 'PlZ, Ort: ...'.BR;
				$text .= 'Datum/Zeit: '.date('d.m.Y').' um '.date('H:i').' Uhr'.BR;
				$text .= 'Anwendung: tkswim '.TKSWIM_VERSION.' ('.TKSWIM_VEREIN.')'.BR;
				$text .= '====================================='.BR.BR;
				# Zusammenfassung
				$text .= 'Zusammenfassung:'.BR;
				$text .= '====================================='.BR;
				$text .= 'Vereins/SG Name: '.TKSWIM_VEREIN.BR;
				$text .= 'DSV-VereinsID: '.TKSWIM_VEREINSID.BR;
				$text .= 'Landesverband: Bayern (2)'.BR;
				$text .= 'mögliche Fachsparte/n: SW'.BR.BR; # per Formular konfigurierbar machen!
				$text .= 'Lizenzen: '.$anz.' (á 12 Euro)'.BR;
				$text .= 'Betrag der an den DSV zu entrichten ist: '.($anz*12).' Euro'.BR;
				$text .= '====================================='.BR.BR;
				# Aktive
				$text .= 'Folgende Aktive möchte ich für das Jahr '.$_POST['jahr'].' lizenzieren:'.BR;
				$text .= '====================================='.BR;
				$query = "SELECT dsvid, nachname, vorname, DATE_FORMAT(gebdatum, '%d.%m.%Y') as geboren FROM ".DB_PREFIX."mitglieder
							WHERE id IN (".implode(',',$ids).") ORDER BY nachname, vorname";
				$_db->holeDaten($query);
				$mitglieder = $_db->baueArray('*', '#');
				foreach($mitglieder as $row){
					$text .= $row['dsvid'].': '.$row['nachname'].', '.$row['vorname'].' '.$row['geboren'].BR;
				}
				$text .= '====================================='.BR.BR;
				# nächste Zeilen konfigurierbar machen!
				$text .= 'Den Betrag von '.($anz*12).' Euro buchen Sie bitte von unserem Konto ab (Einzugsermächtigung liegt vor).'.BR.BR;
				# Gruß
				$text .= 'Mit freundlichen Grüßen'.BR.'[Name]';

				$text = base64_encode($text);
				$text = wordwrap($text, 72, BR, true);

				require_once(PFAD_INCLUDE.'class/mail.inc.php');
				$_email = parse_ini_file(PFAD_INCLUDE.'conf/emails.ini',true);
				$mail = new email;
				$mail->conf = $_email;
				$mail->setzeBetreff('Lizenzierungsantrag '.$_POST['jahr'].' von ID '.TKSWIM_VEREINSID.' - '.TKSWIM_VEREIN, false);
				$mail->setzeText($text);
				$mail->setzeAn('lizenzzahlung@dsv.de'); # Produktiv
				$mail->setzeHeader('BCC', '...');
				$mail->setzeHeader('Reply-To', '...');
				$mail->setzeHeader('Content-Type', 'text/plain; charset=UTF-8');
				$mail->setzeHeader('Content-Transfer-Encoding', 'base64');
				$mail->setzeHeader('From', 'Mitgliederverwaltung des TSV Stein <'.$_email['absender']['email'].'>');
				#$erfolg = $mail->verschickeMail();
			}
			weiterleiten('/wettkaempfe/lizenzen'.TKSWIM_DATEIENDUNG.'?aktion=lizenzierungen',
						'Es wurde'.($anz==1?' 1 Lizenzierung':'n '.$anz.' Lizenzierungen').' für das Jahr '.$_POST['jahr'].' gespeichert'.(isset($_POST['beimdsvbeantragen'])?' und beim DSV beantragt.':'.'));
		}
	}
	if(isset($_POST['speichern']) and in_array($_POST['jahr'],$lizenzjahre) and (!isset($_POST['zulizenzierende']) or count($_POST['zulizenzierende'])<1)){
		$_tmpl->assign('fehler', 'Es wurde kein zu lizenzierender Schwimmer ausgewählt.');
	}
	
	# Schwimmer die noch nicht lizenziert sind
	$mitglieder = array();
	# Mitglieder die nicht auf Wettkaempfe gehen suchen und vormerken
	$query = "SELECT artid FROM ".DB_PREFIX."eigenschaften WHERE art = 'm' AND eigenschaft = 'keinewettkampfteilnahme'";
	$_db->holeDaten($query);
	if($_db->ergebnis['anzahl'] > 0){
		$zuentfernende = $_db->baueArray('artid','#');
	}
	else{
		$zuentfernende = array();
	}
	# 1. Lizenzjahr # z{$jahr}_{$m.id}
	$query = "SELECT m.id, m.nachname, m.vorname, YEAR(gebdatum) as jg, CONCAT('z".$lizenzjahre[1]."_', m.id) as formid
				FROM ".DB_PREFIX."mitglieder as m LEFT JOIN ".DB_PREFIX."lizenzierungen as l ON l.mitgliedid=m.id AND l.jahr = ".$lizenzjahre[1]."
				WHERE l.jahr IS NULL AND dsvid IS NOT NULL AND ausgetreten IS NULL AND (".$lizenzjahre[1]."-YEAR(gebdatum)) >= 10
				ORDER BY nachname, vorname";
	$_db->holeDaten($query);
	$mitglieder[$lizenzjahre[1]] = $_db->baueArray('*','id');
	foreach($zuentfernende as $id){
		if(!isset($mitglieder[$lizenzjahre[1]][$id])){
			continue;
		}
		unset($mitglieder[$lizenzjahre[1]][$id]);
	}
	# 2. Lizenzjahr
	$query = "SELECT m.id, m.nachname, m.vorname, YEAR(gebdatum) as jg, CONCAT('z".$lizenzjahre[2]."_', m.id) as formid
				FROM ".DB_PREFIX."mitglieder as m LEFT JOIN ".DB_PREFIX."lizenzierungen as l ON l.mitgliedid=m.id AND l.jahr = ".$lizenzjahre[2]."
				WHERE l.jahr IS NULL AND dsvid IS NOT NULL AND ausgetreten IS NULL AND (".$lizenzjahre[2]."-YEAR(gebdatum)) >= 10
				ORDER BY nachname, vorname";
	$_db->holeDaten($query);
	$mitglieder[$lizenzjahre[2]] = $_db->baueArray('*','id');
	# Mitglieder die nicht auf Wettkaempfe gehen entfernen
	$query = "SELECT artid FROM ".DB_PREFIX."eigenschaften WHERE art = 'm' AND eigenschaft = 'keinewettkampfteilnahme'";
	$_db->holeDaten($query);
	foreach($zuentfernende as $id){
		if(!isset($mitglieder[$lizenzjahre[2]][$id])){
			continue;
		}
		unset($mitglieder[$lizenzjahre[2]][$id]);
	}
	if(isset($_POST['markiert']) and is_array($_POST['markiert'])){
		$_tmpl->assign('markiert', $_POST['markiert']);
	}
	$_tmpl->assign('mitglieder',$mitglieder);
	
	$_tmpl->tk_javascriptzuweisen('dateien', 'jquery,jquery.ui');
	$_tmpl->tk_javascriptzuweisen('onready', "\$('#tabs').tabs();");
	$_inh .= $_tmpl->fetch('wettkaempfe/46.lizenzen-lizenzieren.inc.html');
	break;

case 'ausgeblendete':
	$query = "SELECT m.nachname, m.vorname, m.id, YEAR(gebdatum) as jg, m.dsvid, e.wert
				FROM ".DB_PREFIX."mitglieder as m LEFT JOIN ".DB_PREFIX."eigenschaften as e
				ON e.artid=m.id AND art='m' AND eigenschaft = 'keinewettkampfteilnahme'
				WHERE dsvid IS NOT NULL AND (e.wert IS NOT NULL or ausgetreten IS NOT NULL) ORDER BY nachname, vorname";
	$_db->holeDaten($query);
	$mitglieder = array();
	foreach($_db->ergebnis['daten'] as $row){
		$mitglieder[$row['id']] = $row;
	}
	$_tmpl->assign('mitglieder',$mitglieder);
	$_inh .= $_tmpl->fetch('wettkaempfe/46.lizenzen-ausgeblendete.inc.html');
	break;

default:
	# Lizenzjahre bestimmen
	$jahr = date('Y');
	$monat = date('m');
	$lizenzjahre = array(
		1 => ($monat<9?$jahr-1:$jahr),
		2 => ($monat<9?$jahr:$jahr+1)
	);
	# Liste holen
	$query = "SELECT m.nachname, m.vorname, m.id, YEAR(gebdatum) as jg, m.dsvid, e.wert
				FROM ".DB_PREFIX."mitglieder as m LEFT JOIN ".DB_PREFIX."eigenschaften as e
				ON e.artid=m.id AND art='m' AND eigenschaft = 'dsvidbeantragt'
				WHERE (m.dsvid IS NOT NULL OR e.wert IS NOT NULL) AND ausgetreten IS NULL ORDER BY nachname, vorname";
	$_db->holeDaten($query);
	$mitglieder = array();
	foreach($_db->ergebnis['daten'] as $row){
		$row['L1'] = (($lizenzjahre[1]-$row['jg'])<10)?'nn':'-';
		$row['L2'] = (($lizenzjahre[2]-$row['jg'])<10)?'nn':'-';
		$mitglieder[$row['id']] = $row;
	}
	# auszublendende holen
	$query = "SELECT artid FROM ".DB_PREFIX."eigenschaften WHERE art = 'm' AND eigenschaft = 'keinewettkampfteilnahme'";
	$_db->holeDaten($query);
	$entfernen = $_db->baueArray('artid','#');
	foreach($mitglieder as $id => $row){
		if(in_array($id,$entfernen)){
			unset($mitglieder[$id]);
		}
	}
	# Lizenzen holen
	$query = "SELECT mitgliedid, jahr FROM ".DB_PREFIX."lizenzierungen WHERE jahr IN (".$lizenzjahre[1].",".$lizenzjahre[2].")";
	$_db->holeDaten($query);
	$anzahl = array('L1'=>0,'L2'=>0);
	if($_db->ergebnis['anzahl'] != 0){
		foreach($_db->ergebnis['daten'] as $row){
			if(!isset($mitglieder[$row['mitgliedid']])){
				continue;
			}
			$L = ($row['jahr']==$lizenzjahre[1])?'L1':'L2';
			$mitglieder[$row['mitgliedid']][$L] = 'x';
			$anzahl[$L]++;
		}
	}
	$anzahl['schwimmer'] = count($mitglieder);
	# Daten an Template zuweisen und ausgeben
	$_tmpl->assign('anzahl',$anzahl);
	$_tmpl->assign('lizenzjahre',$lizenzjahre);
	$_tmpl->assign('mitglieder',$mitglieder);
	$_inh .= $_tmpl->fetch('wettkaempfe/46.lizenzen-index.inc.html');
	break;
}
} # Ende Rechte-else
require_once('../__inc/_ende.inc.php');
# EOF
?>